/************************************************************************/
/* Licensed Materials – Property of  HCL                                */
/* (c) Copyright HCL Technologies Ltd. 2016, 2017 All rights reserved.  */
/* Trademark of HCL Technologies Limited                                */
/************************************************************************/


module.exports = function (dbName) {

	var mongoose = require('mongoose');
	var Schema = mongoose.Schema;

	var connection = mongoose.createConnection(config.mongodbURL); // connect to our database
	//console.log('DB OPEN');

	// schema
	var dbSchema = new Schema({
		id: String,             // declare only fields which all cells will have
		_id: String,
		type: String
	}, {
			collection: dbName,
			strict: false,          // we don't declare all fields
			versionKey: false       // dont use _v (mongoose) for versioning
		});

	// model
	var DB = connection.model(dbName, dbSchema);

	DB.closeConnection = function () {
		connection.close();
		//console.log('DB CLOSE');
	};

	return DB;

};