/************************************************************************/
/* Licensed Materials – Property of  HCL                                */
/* (c) Copyright HCL Technologies Ltd. 2016, 2017 All rights reserved.  */
/* Trademark of HCL Technologies Limited                                */
/************************************************************************/

// app/models/modelElement.js
// load the things we need
var mongoose = require('mongoose');
var Schema = mongoose.Schema;
var findOrCreate = require('mongoose-findorcreate');

var connection = mongoose.createConnection(config.mongodbURL); // connect to our database

// define the schema for our modelElement
var modelElementSchema = new Schema({
	_id: String, // model_id
	cell : Schema.Types.Mixed
}, {
		collection: 'modelElements',
		strict: false,          // we don't declare all fields
		versionKey: false       // dont use _v (mongoose) for versioning
	});


modelElementSchema.plugin(findOrCreate);

// model
var ModelElements = connection.model('ModelElement', modelElementSchema);

ModelElements.closeConnection = function () {
	connection.close();
	//console.log('ROOM CLOSE');
};

// make this available to our users in our Node applications
module.exports = ModelElements;

