/************************************************************************/
/* Licensed Materials – Property of  HCL                                */
/* (c) Copyright HCL Technologies Ltd. 2016, 2017 All rights reserved.  */
/* Trademark of HCL Technologies Limited                                */
/************************************************************************/

var mongoose = require('mongoose');
var Schema = mongoose.Schema;

var findOrCreate = require('mongoose-findorcreate');

var connection = mongoose.createConnection(config.mongodbURL); // connect to our database
//console.log('ROOM OPEN');

// schema
var roomsSchema = new Schema({
	_id: String,
	id: String,
	name: String,
	whiteboards: []
}, {
		collection: 'room',
		strict: false,          // we don't declare all fields
		versionKey: false,       // dont use _v (mongoose) for versioning
		usePushEach: true
	});


roomsSchema.plugin(findOrCreate);

// model
var Rooms = connection.model('room', roomsSchema);

Rooms.closeConnection = function () {
	connection.close();
	//console.log('ROOM CLOSE');
};

// make this available to our users in our Node applications
module.exports = Rooms;