/************************************************************************/
/* Licensed Materials – Property of  HCL                                */
/* (c) Copyright HCL Technologies Ltd. 2016, 2017 All rights reserved.  */
/* Trademark of HCL Technologies Limited                                */
/************************************************************************/

var workManager = require('../modules/workManager');

module.exports = function () {
	var Exporter = {};

	Exporter.doExport = function (expImpPath) {
		var config = require('../modules/config');
		const fs = require('fs-extra');
		var Users = require('../models/user');

		workManager.workStarted();

		Users.find({}, function (err, users) {
			if (err) throw err;

			fs.ensureDir(expImpPath, function (err) {
				if (err) throw err;

				var usersFile = expImpPath + '/' + 'users.json';
				fs.outputJson(usersFile, users, { spaces: 4 }, function (err) {
					Users.closeConnection();
					if (err) throw err;
					winston.info('Exported Users to - ', usersFile);
					workManager.workEnded();

				});

			});

		});

	};

	return Exporter;
};