/*! Rappid v2.1.0 - HTML5 Diagramming Framework

Copyright (c) 2015 client IO

 2017-03-31 


This Source Code Form is subject to the terms of the Rappid License
, v. 2.0. If a copy of the Rappid License was not distributed with this
file, You can obtain one at http://jointjs.com/license/rappid_v2.txt
 or from the Rappid archive as was distributed by client IO. See the LICENSE file.*/

/*!
 * A class to parse color values
 * @author Stoyan Stefanov <sstoo@gmail.com>
 * @link   http://www.phpied.com/rgb-color-parser-in-javascript/
 * @license Use it if you like it
 */

/*!

StackBlur - a fast almost Gaussian Blur For Canvas

Version: 	0.5
Author:		Mario Klingemann
Contact: 	mario@quasimondo.com
Website:	http://www.quasimondo.com/StackBlurForCanvas
Twitter:	@quasimondo

In case you find this class useful - especially in commercial projects -
I am not totally unhappy for a small donation to my PayPal account
mario@quasimondo.de

Or support me on flattr: 
https://flattr.com/thing/72791/StackBlur-a-fast-almost-Gaussian-Blur-Effect-for-CanvasJavascript

Copyright (c) 2010 Mario Klingemann

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

/*!
 * canvg.js - Javascript SVG parser and renderer on Canvas
 * MIT Licensed 
 * Gabe Lerner (gabelerner@gmail.com)
 * http://code.google.com/p/canvg/
 *
 * Requires: rgbcolor.js - http://www.phpied.com/rgb-color-parser-in-javascript/
 */

function RGBColor(t){this.ok=!1,"#"==t.charAt(0)&&(t=t.substr(1,6)),t=t.replace(/ /g,""),t=t.toLowerCase();var e={aliceblue:"f0f8ff",antiquewhite:"faebd7",aqua:"00ffff",aquamarine:"7fffd4",azure:"f0ffff",beige:"f5f5dc",bisque:"ffe4c4",black:"000000",blanchedalmond:"ffebcd",blue:"0000ff",blueviolet:"8a2be2",brown:"a52a2a",burlywood:"deb887",cadetblue:"5f9ea0",chartreuse:"7fff00",chocolate:"d2691e",coral:"ff7f50",cornflowerblue:"6495ed",cornsilk:"fff8dc",crimson:"dc143c",cyan:"00ffff",darkblue:"00008b",darkcyan:"008b8b",darkgoldenrod:"b8860b",darkgray:"a9a9a9",darkgreen:"006400",darkkhaki:"bdb76b",darkmagenta:"8b008b",darkolivegreen:"556b2f",darkorange:"ff8c00",darkorchid:"9932cc",darkred:"8b0000",darksalmon:"e9967a",darkseagreen:"8fbc8f",darkslateblue:"483d8b",darkslategray:"2f4f4f",darkturquoise:"00ced1",darkviolet:"9400d3",deeppink:"ff1493",deepskyblue:"00bfff",dimgray:"696969",dodgerblue:"1e90ff",feldspar:"d19275",firebrick:"b22222",floralwhite:"fffaf0",forestgreen:"228b22",fuchsia:"ff00ff",gainsboro:"dcdcdc",ghostwhite:"f8f8ff",gold:"ffd700",goldenrod:"daa520",gray:"808080",green:"008000",greenyellow:"adff2f",honeydew:"f0fff0",hotpink:"ff69b4",indianred:"cd5c5c",indigo:"4b0082",ivory:"fffff0",khaki:"f0e68c",lavender:"e6e6fa",lavenderblush:"fff0f5",lawngreen:"7cfc00",lemonchiffon:"fffacd",lightblue:"add8e6",lightcoral:"f08080",lightcyan:"e0ffff",lightgoldenrodyellow:"fafad2",lightgrey:"d3d3d3",lightgreen:"90ee90",lightpink:"ffb6c1",lightsalmon:"ffa07a",lightseagreen:"20b2aa",lightskyblue:"87cefa",lightslateblue:"8470ff",lightslategray:"778899",lightsteelblue:"b0c4de",lightyellow:"ffffe0",lime:"00ff00",limegreen:"32cd32",linen:"faf0e6",magenta:"ff00ff",maroon:"800000",mediumaquamarine:"66cdaa",mediumblue:"0000cd",mediumorchid:"ba55d3",mediumpurple:"9370d8",mediumseagreen:"3cb371",mediumslateblue:"7b68ee",mediumspringgreen:"00fa9a",mediumturquoise:"48d1cc",mediumvioletred:"c71585",midnightblue:"191970",mintcream:"f5fffa",mistyrose:"ffe4e1",moccasin:"ffe4b5",navajowhite:"ffdead",navy:"000080",oldlace:"fdf5e6",olive:"808000",olivedrab:"6b8e23",orange:"ffa500",orangered:"ff4500",orchid:"da70d6",palegoldenrod:"eee8aa",palegreen:"98fb98",paleturquoise:"afeeee",palevioletred:"d87093",papayawhip:"ffefd5",peachpuff:"ffdab9",peru:"cd853f",pink:"ffc0cb",plum:"dda0dd",powderblue:"b0e0e6",purple:"800080",red:"ff0000",rosybrown:"bc8f8f",royalblue:"4169e1",saddlebrown:"8b4513",salmon:"fa8072",sandybrown:"f4a460",seagreen:"2e8b57",seashell:"fff5ee",sienna:"a0522d",silver:"c0c0c0",skyblue:"87ceeb",slateblue:"6a5acd",slategray:"708090",snow:"fffafa",springgreen:"00ff7f",steelblue:"4682b4",tan:"d2b48c",teal:"008080",thistle:"d8bfd8",tomato:"ff6347",turquoise:"40e0d0",violet:"ee82ee",violetred:"d02090",wheat:"f5deb3",white:"ffffff",whitesmoke:"f5f5f5",yellow:"ffff00",yellowgreen:"9acd32"};for(var i in e)t==i&&(t=e[i]);for(var n=[{re:/^rgb\((\d{1,3}),\s*(\d{1,3}),\s*(\d{1,3})\)$/,example:["rgb(123, 234, 45)","rgb(255,234,245)"],process:function(t){return[parseInt(t[1]),parseInt(t[2]),parseInt(t[3])]}},{re:/^(\w{2})(\w{2})(\w{2})$/,example:["#00ff00","336699"],process:function(t){return[parseInt(t[1],16),parseInt(t[2],16),parseInt(t[3],16)]}},{re:/^(\w{1})(\w{1})(\w{1})$/,example:["#fb0","f0f"],process:function(t){return[parseInt(t[1]+t[1],16),parseInt(t[2]+t[2],16),parseInt(t[3]+t[3],16)]}}],a=0;a<n.length;a++){var s=n[a].re,r=n[a].process,o=s.exec(t);o&&(channels=r(o),this.r=channels[0],this.g=channels[1],this.b=channels[2],this.ok=!0)}this.r=this.r<0||isNaN(this.r)?0:this.r>255?255:this.r,this.g=this.g<0||isNaN(this.g)?0:this.g>255?255:this.g,this.b=this.b<0||isNaN(this.b)?0:this.b>255?255:this.b,this.toRGB=function(){return"rgb("+this.r+", "+this.g+", "+this.b+")"},this.toHex=function(){var t=this.r.toString(16),e=this.g.toString(16),i=this.b.toString(16);return 1==t.length&&(t="0"+t),1==e.length&&(e="0"+e),1==i.length&&(i="0"+i),"#"+t+e+i},this.getHelpXML=function(){for(var t=new Array,i=0;i<n.length;i++)for(var a=n[i].example,s=0;s<a.length;s++)t[t.length]=a[s];for(var r in e)t[t.length]=r;var o=document.createElement("ul");o.setAttribute("id","rgbcolor-examples");for(var i=0;i<t.length;i++)try{var l=document.createElement("li"),h=new RGBColor(t[i]),u=document.createElement("div");u.style.cssText="margin: 3px; border: 1px solid black; background:"+h.toHex()+"; color:"+h.toHex(),u.appendChild(document.createTextNode("test"));var f=document.createTextNode(" "+t[i]+" -> "+h.toRGB()+" -> "+h.toHex());l.appendChild(u),l.appendChild(f),o.appendChild(l)}catch(t){}return o}}function stackBlurImage(t,e,i,n){var a=document.getElementById(t),s=a.naturalWidth,r=a.naturalHeight,o=document.getElementById(e);o.style.width=s+"px",o.style.height=r+"px",o.width=s,o.height=r;var l=o.getContext("2d");l.clearRect(0,0,s,r),l.drawImage(a,0,0),isNaN(i)||i<1||(n?stackBlurCanvasRGBA(e,0,0,s,r,i):stackBlurCanvasRGB(e,0,0,s,r,i))}function stackBlurCanvasRGBA(t,e,i,n,a,s){if(!(isNaN(s)||s<1)){s|=0;var r,o=document.getElementById(t),l=o.getContext("2d");try{try{r=l.getImageData(e,i,n,a)}catch(t){try{netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead"),r=l.getImageData(e,i,n,a)}catch(t){throw alert("Cannot access local image"),new Error("unable to access local image data: "+t)}}}catch(t){throw alert("Cannot access image"),new Error("unable to access image data: "+t)}var h,u,f,c,d,m,p,g,y,v,b,x,w,E,P,B,C,V,k,T,M,S,A,R,D=r.data,N=s+s+1,I=n-1,z=a-1,O=s+1,X=O*(O+1)/2,G=new BlurStack,L=G;for(f=1;f<N;f++)if(L=L.next=new BlurStack,f==O)var q=L;L.next=G;var F=null,U=null;p=m=0;var $=mul_table[s],H=shg_table[s];for(u=0;u<a;u++){for(B=C=V=k=g=y=v=b=0,x=O*(T=D[m]),w=O*(M=D[m+1]),E=O*(S=D[m+2]),P=O*(A=D[m+3]),g+=X*T,y+=X*M,v+=X*S,b+=X*A,L=G,f=0;f<O;f++)L.r=T,L.g=M,L.b=S,L.a=A,L=L.next;for(f=1;f<O;f++)c=m+((I<f?I:f)<<2),g+=(L.r=T=D[c])*(R=O-f),y+=(L.g=M=D[c+1])*R,v+=(L.b=S=D[c+2])*R,b+=(L.a=A=D[c+3])*R,B+=T,C+=M,V+=S,k+=A,L=L.next;for(F=G,U=q,h=0;h<n;h++)D[m+3]=A=b*$>>H,0!=A?(A=255/A,D[m]=(g*$>>H)*A,D[m+1]=(y*$>>H)*A,D[m+2]=(v*$>>H)*A):D[m]=D[m+1]=D[m+2]=0,g-=x,y-=w,v-=E,b-=P,x-=F.r,w-=F.g,E-=F.b,P-=F.a,c=p+((c=h+s+1)<I?c:I)<<2,B+=F.r=D[c],C+=F.g=D[c+1],V+=F.b=D[c+2],k+=F.a=D[c+3],g+=B,y+=C,v+=V,b+=k,F=F.next,x+=T=U.r,w+=M=U.g,E+=S=U.b,P+=A=U.a,B-=T,C-=M,V-=S,k-=A,U=U.next,m+=4;p+=n}for(h=0;h<n;h++){for(C=V=k=B=y=v=b=g=0,m=h<<2,x=O*(T=D[m]),w=O*(M=D[m+1]),E=O*(S=D[m+2]),P=O*(A=D[m+3]),g+=X*T,y+=X*M,v+=X*S,b+=X*A,L=G,f=0;f<O;f++)L.r=T,L.g=M,L.b=S,L.a=A,L=L.next;for(d=n,f=1;f<=s;f++)m=d+h<<2,g+=(L.r=T=D[m])*(R=O-f),y+=(L.g=M=D[m+1])*R,v+=(L.b=S=D[m+2])*R,b+=(L.a=A=D[m+3])*R,B+=T,C+=M,V+=S,k+=A,L=L.next,f<z&&(d+=n);for(m=h,F=G,U=q,u=0;u<a;u++)c=m<<2,D[c+3]=A=b*$>>H,A>0?(A=255/A,D[c]=(g*$>>H)*A,D[c+1]=(y*$>>H)*A,D[c+2]=(v*$>>H)*A):D[c]=D[c+1]=D[c+2]=0,g-=x,y-=w,v-=E,b-=P,x-=F.r,w-=F.g,E-=F.b,P-=F.a,c=h+((c=u+O)<z?c:z)*n<<2,g+=B+=F.r=D[c],y+=C+=F.g=D[c+1],v+=V+=F.b=D[c+2],b+=k+=F.a=D[c+3],F=F.next,x+=T=U.r,w+=M=U.g,E+=S=U.b,P+=A=U.a,B-=T,C-=M,V-=S,k-=A,U=U.next,m+=n}l.putImageData(r,e,i)}}function stackBlurCanvasRGB(t,e,i,n,a,s){if(!(isNaN(s)||s<1)){s|=0;var r,o=document.getElementById(t),l=o.getContext("2d");try{try{r=l.getImageData(e,i,n,a)}catch(t){try{netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead"),r=l.getImageData(e,i,n,a)}catch(t){throw alert("Cannot access local image"),new Error("unable to access local image data: "+t)}}}catch(t){throw alert("Cannot access image"),new Error("unable to access image data: "+t)}var h,u,f,c,d,m,p,g,y,v,b,x,w,E,P,B,C,V,k,T,M=r.data,S=s+s+1,A=n-1,R=a-1,D=s+1,N=D*(D+1)/2,I=new BlurStack,z=I;for(f=1;f<S;f++)if(z=z.next=new BlurStack,f==D)var O=z;z.next=I;var X=null,G=null;p=m=0;var L=mul_table[s],q=shg_table[s];for(u=0;u<a;u++){for(E=P=B=g=y=v=0,b=D*(C=M[m]),x=D*(V=M[m+1]),w=D*(k=M[m+2]),g+=N*C,y+=N*V,v+=N*k,z=I,f=0;f<D;f++)z.r=C,z.g=V,z.b=k,z=z.next;for(f=1;f<D;f++)c=m+((A<f?A:f)<<2),g+=(z.r=C=M[c])*(T=D-f),y+=(z.g=V=M[c+1])*T,v+=(z.b=k=M[c+2])*T,E+=C,P+=V,B+=k,z=z.next;for(X=I,G=O,h=0;h<n;h++)M[m]=g*L>>q,M[m+1]=y*L>>q,M[m+2]=v*L>>q,g-=b,y-=x,v-=w,b-=X.r,x-=X.g,w-=X.b,c=p+((c=h+s+1)<A?c:A)<<2,E+=X.r=M[c],P+=X.g=M[c+1],B+=X.b=M[c+2],g+=E,y+=P,v+=B,X=X.next,b+=C=G.r,x+=V=G.g,w+=k=G.b,E-=C,P-=V,B-=k,G=G.next,m+=4;p+=n}for(h=0;h<n;h++){for(P=B=E=y=v=g=0,m=h<<2,b=D*(C=M[m]),x=D*(V=M[m+1]),w=D*(k=M[m+2]),g+=N*C,y+=N*V,v+=N*k,z=I,f=0;f<D;f++)z.r=C,z.g=V,z.b=k,z=z.next;for(d=n,f=1;f<=s;f++)m=d+h<<2,g+=(z.r=C=M[m])*(T=D-f),y+=(z.g=V=M[m+1])*T,v+=(z.b=k=M[m+2])*T,E+=C,P+=V,B+=k,z=z.next,f<R&&(d+=n);for(m=h,X=I,G=O,u=0;u<a;u++)c=m<<2,M[c]=g*L>>q,M[c+1]=y*L>>q,M[c+2]=v*L>>q,g-=b,y-=x,v-=w,b-=X.r,x-=X.g,w-=X.b,c=h+((c=u+D)<R?c:R)*n<<2,g+=E+=X.r=M[c],y+=P+=X.g=M[c+1],v+=B+=X.b=M[c+2],X=X.next,b+=C=G.r,x+=V=G.g,w+=k=G.b,E-=C,P-=V,B-=k,G=G.next,m+=n}l.putImageData(r,e,i)}}function BlurStack(){this.r=0,this.g=0,this.b=0,this.a=0,this.next=null}var mul_table=[512,512,456,512,328,456,335,512,405,328,271,456,388,335,292,512,454,405,364,328,298,271,496,456,420,388,360,335,312,292,273,512,482,454,428,405,383,364,345,328,312,298,284,271,259,496,475,456,437,420,404,388,374,360,347,335,323,312,302,292,282,273,265,512,497,482,468,454,441,428,417,405,394,383,373,364,354,345,337,328,320,312,305,298,291,284,278,271,265,259,507,496,485,475,465,456,446,437,428,420,412,404,396,388,381,374,367,360,354,347,341,335,329,323,318,312,307,302,297,292,287,282,278,273,269,265,261,512,505,497,489,482,475,468,461,454,447,441,435,428,422,417,411,405,399,394,389,383,378,373,368,364,359,354,350,345,341,337,332,328,324,320,316,312,309,305,301,298,294,291,287,284,281,278,274,271,268,265,262,259,257,507,501,496,491,485,480,475,470,465,460,456,451,446,442,437,433,428,424,420,416,412,408,404,400,396,392,388,385,381,377,374,370,367,363,360,357,354,350,347,344,341,338,335,332,329,326,323,320,318,315,312,310,307,304,302,299,297,294,292,289,287,285,282,280,278,275,273,271,269,267,265,263,261,259],shg_table=[9,11,12,13,13,14,14,15,15,15,15,16,16,16,16,17,17,17,17,17,17,17,18,18,18,18,18,18,18,18,18,19,19,19,19,19,19,19,19,19,19,19,19,19,19,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,23,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24];!function(){function t(){var t={};return t.FRAMERATE=30,t.MAX_VIRTUAL_PIXELS=3e4,t.init=function(e){var i=0;t.UniqueId=function(){return"canvg"+ ++i},t.Definitions={},t.Styles={},t.Animations=[],t.Images=[],t.ctx=e,t.ViewPort=new function(){this.viewPorts=[],this.Clear=function(){this.viewPorts=[]},this.SetCurrent=function(t,e){this.viewPorts.push({width:t,height:e})},this.RemoveCurrent=function(){this.viewPorts.pop()},this.Current=function(){return this.viewPorts[this.viewPorts.length-1]},this.width=function(){return this.Current().width},this.height=function(){return this.Current().height},this.ComputeSize=function(t){return null!=t&&"number"==typeof t?t:"x"==t?this.width():"y"==t?this.height():Math.sqrt(Math.pow(this.width(),2)+Math.pow(this.height(),2))/Math.sqrt(2)}}},t.init(),t.ImagesLoaded=function(){for(var e=0;e<t.Images.length;e++)if(!t.Images[e].loaded)return!1;return!0},t.trim=function(t){return t.replace(/^\s+|\s+$/g,"")},t.compressSpaces=function(t){return t.replace(/[\s\r\t\n]+/gm," ")},t.ajax=function(t){var e;return e=window.XMLHttpRequest?new XMLHttpRequest:new ActiveXObject("Microsoft.XMLHTTP"),e?(e.open("GET",t,!1),e.send(null),e.responseText):null},t.parseXml=function(t){if(window.DOMParser){return(new DOMParser).parseFromString(t,"text/xml")}t=t.replace(/<!DOCTYPE svg[^>]*>/,"");var e=new ActiveXObject("Microsoft.XMLDOM");return e.async="false",e.loadXML(t),e},t.Property=function(t,e){this.name=t,this.value=e},t.Property.prototype.getValue=function(){return this.value},t.Property.prototype.hasValue=function(){return null!=this.value&&""!==this.value},t.Property.prototype.numValue=function(){if(!this.hasValue())return 0;var t=parseFloat(this.value);return(this.value+"").match(/%$/)&&(t/=100),t},t.Property.prototype.valueOrDefault=function(t){return this.hasValue()?this.value:t},t.Property.prototype.numValueOrDefault=function(t){return this.hasValue()?this.numValue():t},t.Property.prototype.addOpacity=function(e){var i=this.value;if(null!=e&&""!=e&&"string"==typeof this.value){var n=new RGBColor(this.value);n.ok&&(i="rgba("+n.r+", "+n.g+", "+n.b+", "+e+")")}return new t.Property(this.name,i)},t.Property.prototype.getDefinition=function(){var e=this.value.match(/#([^\)'"]+)/);return e&&(e=e[1]),e||(e=this.value),t.Definitions[e]},t.Property.prototype.isUrlDefinition=function(){return 0==this.value.indexOf("url(")},t.Property.prototype.getFillStyleDefinition=function(e,i){var n=this.getDefinition();if(null!=n&&n.createGradient)return n.createGradient(t.ctx,e,i);if(null!=n&&n.createPattern){if(n.getHrefAttribute().hasValue()){var a=n.attribute("patternTransform");n=n.getHrefAttribute().getDefinition(),a.hasValue()&&(n.attribute("patternTransform",!0).value=a.value)}return n.createPattern(t.ctx,e)}return null},t.Property.prototype.getDPI=function(t){return 96},t.Property.prototype.getEM=function(e){var i=12,n=new t.Property("fontSize",t.Font.Parse(t.ctx.font).fontSize);return n.hasValue()&&(i=n.toPixels(e)),i},t.Property.prototype.getUnits=function(){return(this.value+"").replace(/[0-9\.\-]/g,"")},t.Property.prototype.toPixels=function(e,i){if(!this.hasValue())return 0;var n=this.value+"";if(n.match(/em$/))return this.numValue()*this.getEM(e);if(n.match(/ex$/))return this.numValue()*this.getEM(e)/2;if(n.match(/px$/))return this.numValue();if(n.match(/pt$/))return this.numValue()*this.getDPI(e)*(1/72);if(n.match(/pc$/))return 15*this.numValue();if(n.match(/cm$/))return this.numValue()*this.getDPI(e)/2.54;if(n.match(/mm$/))return this.numValue()*this.getDPI(e)/25.4;if(n.match(/in$/))return this.numValue()*this.getDPI(e);if(n.match(/%$/))return this.numValue()*t.ViewPort.ComputeSize(e);var a=this.numValue();return i&&a<1?a*t.ViewPort.ComputeSize(e):a},t.Property.prototype.toMilliseconds=function(){if(!this.hasValue())return 0;var t=this.value+"";return t.match(/s$/)?1e3*this.numValue():(t.match(/ms$/),this.numValue())},t.Property.prototype.toRadians=function(){if(!this.hasValue())return 0;var t=this.value+"";return t.match(/deg$/)?this.numValue()*(Math.PI/180):t.match(/grad$/)?this.numValue()*(Math.PI/200):t.match(/rad$/)?this.numValue():this.numValue()*(Math.PI/180)},t.Font=new function(){this.Styles="normal|italic|oblique|inherit",this.Variants="normal|small-caps|inherit",this.Weights="normal|bold|bolder|lighter|100|200|300|400|500|600|700|800|900|inherit",this.CreateFont=function(e,i,n,a,s,r){var o=null!=r?this.Parse(r):this.CreateFont("","","","","",t.ctx.font);return{fontFamily:s||o.fontFamily,fontSize:a||o.fontSize,fontStyle:e||o.fontStyle,fontWeight:n||o.fontWeight,fontVariant:i||o.fontVariant,toString:function(){return[this.fontStyle,this.fontVariant,this.fontWeight,this.fontSize,this.fontFamily].join(" ")}}};var e=this;this.Parse=function(i){for(var n={},a=t.trim(t.compressSpaces(i||"")).split(" "),s={fontSize:!1,fontStyle:!1,fontWeight:!1,fontVariant:!1},r="",o=0;o<a.length;o++)s.fontStyle||-1==e.Styles.indexOf(a[o])?s.fontVariant||-1==e.Variants.indexOf(a[o])?s.fontWeight||-1==e.Weights.indexOf(a[o])?s.fontSize?"inherit"!=a[o]&&(r+=a[o]):("inherit"!=a[o]&&(n.fontSize=a[o].split("/")[0]),s.fontStyle=s.fontVariant=s.fontWeight=s.fontSize=!0):("inherit"!=a[o]&&(n.fontWeight=a[o]),s.fontStyle=s.fontVariant=s.fontWeight=!0):("inherit"!=a[o]&&(n.fontVariant=a[o]),s.fontStyle=s.fontVariant=!0):("inherit"!=a[o]&&(n.fontStyle=a[o]),s.fontStyle=!0);return""!=r&&(n.fontFamily=r),n}},t.ToNumberArray=function(e){for(var i=t.trim(t.compressSpaces((e||"").replace(/,/g," "))).split(" "),n=0;n<i.length;n++)i[n]=parseFloat(i[n]);return i},t.Point=function(t,e){this.x=t,this.y=e},t.Point.prototype.angleTo=function(t){return Math.atan2(t.y-this.y,t.x-this.x)},t.Point.prototype.applyTransform=function(t){var e=this.x*t[0]+this.y*t[2]+t[4],i=this.x*t[1]+this.y*t[3]+t[5];this.x=e,this.y=i},t.CreatePoint=function(e){var i=t.ToNumberArray(e);return new t.Point(i[0],i[1])},t.CreatePath=function(e){for(var i=t.ToNumberArray(e),n=[],a=0;a<i.length;a+=2)n.push(new t.Point(i[a],i[a+1]));return n},t.BoundingBox=function(t,e,n,a){this.x1=Number.NaN,this.y1=Number.NaN,this.x2=Number.NaN,this.y2=Number.NaN,this.x=function(){return this.x1},this.y=function(){return this.y1},this.width=function(){return this.x2-this.x1},this.height=function(){return this.y2-this.y1},this.addPoint=function(t,e){null!=t&&((isNaN(this.x1)||isNaN(this.x2))&&(this.x1=t,this.x2=t),t<this.x1&&(this.x1=t),t>this.x2&&(this.x2=t)),null!=e&&((isNaN(this.y1)||isNaN(this.y2))&&(this.y1=e,this.y2=e),e<this.y1&&(this.y1=e),e>this.y2&&(this.y2=e))},this.addX=function(t){this.addPoint(t,null)},this.addY=function(t){this.addPoint(null,t)},this.addBoundingBox=function(t){this.addPoint(t.x1,t.y1),this.addPoint(t.x2,t.y2)},this.addQuadraticCurve=function(t,e,i,n,a,s){var r=t+2/3*(i-t),o=e+2/3*(n-e),l=r+1/3*(a-t),h=o+1/3*(s-e);this.addBezierCurve(t,e,r,l,o,h,a,s)},this.addBezierCurve=function(t,e,n,a,s,r,o,l){var h=[t,e],u=[n,a],f=[s,r],c=[o,l];for(this.addPoint(h[0],h[1]),this.addPoint(c[0],c[1]),i=0;i<=1;i++){var d=function(t){return Math.pow(1-t,3)*h[i]+3*Math.pow(1-t,2)*t*u[i]+3*(1-t)*Math.pow(t,2)*f[i]+Math.pow(t,3)*c[i]},m=6*h[i]-12*u[i]+6*f[i],p=-3*h[i]+9*u[i]-9*f[i]+3*c[i],g=3*u[i]-3*h[i];if(0!=p){var y=Math.pow(m,2)-4*g*p;if(!(y<0)){var v=(-m+Math.sqrt(y))/(2*p);0<v&&v<1&&(0==i&&this.addX(d(v)),1==i&&this.addY(d(v)));var b=(-m-Math.sqrt(y))/(2*p);0<b&&b<1&&(0==i&&this.addX(d(b)),1==i&&this.addY(d(b)))}}else{if(0==m)continue;var x=-g/m;0<x&&x<1&&(0==i&&this.addX(d(x)),1==i&&this.addY(d(x)))}}},this.isPointInBox=function(t,e){return this.x1<=t&&t<=this.x2&&this.y1<=e&&e<=this.y2},this.addPoint(t,e),this.addPoint(n,a)},t.Transform=function(e){var i=this;this.Type={},this.Type.translate=function(e){this.p=t.CreatePoint(e),this.apply=function(t){t.translate(this.p.x||0,this.p.y||0)},this.unapply=function(t){t.translate(-1*this.p.x||0,-1*this.p.y||0)},this.applyToPoint=function(t){t.applyTransform([1,0,0,1,this.p.x||0,this.p.y||0])}},this.Type.rotate=function(e){var i=t.ToNumberArray(e);this.angle=new t.Property("angle",i[0]),this.cx=i[1]||0,this.cy=i[2]||0,this.apply=function(t){t.translate(this.cx,this.cy),t.rotate(this.angle.toRadians()),t.translate(-this.cx,-this.cy)},this.unapply=function(t){t.translate(this.cx,this.cy),t.rotate(-1*this.angle.toRadians()),t.translate(-this.cx,-this.cy)},this.applyToPoint=function(t){var e=this.angle.toRadians();t.applyTransform([1,0,0,1,this.p.x||0,this.p.y||0]),t.applyTransform([Math.cos(e),Math.sin(e),-Math.sin(e),Math.cos(e),0,0]),t.applyTransform([1,0,0,1,-this.p.x||0,-this.p.y||0])}},this.Type.scale=function(e){this.p=t.CreatePoint(e),this.apply=function(t){t.scale(this.p.x||1,this.p.y||this.p.x||1)},this.unapply=function(t){t.scale(1/this.p.x||1,1/this.p.y||this.p.x||1)},this.applyToPoint=function(t){t.applyTransform([this.p.x||0,0,0,this.p.y||0,0,0])}},this.Type.matrix=function(e){this.m=t.ToNumberArray(e),this.apply=function(t){t.transform(this.m[0],this.m[1],this.m[2],this.m[3],this.m[4],this.m[5])},this.applyToPoint=function(t){t.applyTransform(this.m)}},this.Type.SkewBase=function(e){this.base=i.Type.matrix,this.base(e),this.angle=new t.Property("angle",e)},this.Type.SkewBase.prototype=new this.Type.matrix,this.Type.skewX=function(t){this.base=i.Type.SkewBase,this.base(t),this.m=[1,0,Math.tan(this.angle.toRadians()),1,0,0]},this.Type.skewX.prototype=new this.Type.SkewBase,this.Type.skewY=function(t){this.base=i.Type.SkewBase,this.base(t),this.m=[1,Math.tan(this.angle.toRadians()),0,1,0,0]},this.Type.skewY.prototype=new this.Type.SkewBase,this.transforms=[],this.apply=function(t){for(var e=0;e<this.transforms.length;e++)this.transforms[e].apply(t)},this.unapply=function(t){for(var e=this.transforms.length-1;e>=0;e--)this.transforms[e].unapply(t)},this.applyToPoint=function(t){for(var e=0;e<this.transforms.length;e++)this.transforms[e].applyToPoint(t)};for(var n=t.trim(t.compressSpaces(e)).replace(/\)(\s?,\s?)/g,") ").split(/\s(?=[a-z])/),a=0;a<n.length;a++){var s=t.trim(n[a].split("(")[0]),r=n[a].split("(")[1].replace(")",""),o=new this.Type[s](r);o.type=s,this.transforms.push(o)}},t.AspectRatio=function(e,i,n,a,s,r,o,l,h,u){i=t.compressSpaces(i),i=i.replace(/^defer\s/,"");var f=i.split(" ")[0]||"xMidYMid",c=i.split(" ")[1]||"meet",d=n/a,m=s/r,p=Math.min(d,m),g=Math.max(d,m);"meet"==c&&(a*=p,r*=p),"slice"==c&&(a*=g,r*=g),h=new t.Property("refX",h),u=new t.Property("refY",u),h.hasValue()&&u.hasValue()?e.translate(-p*h.toPixels("x"),-p*u.toPixels("y")):(f.match(/^xMid/)&&("meet"==c&&p==m||"slice"==c&&g==m)&&e.translate(n/2-a/2,0),f.match(/YMid$/)&&("meet"==c&&p==d||"slice"==c&&g==d)&&e.translate(0,s/2-r/2),f.match(/^xMax/)&&("meet"==c&&p==m||"slice"==c&&g==m)&&e.translate(n-a,0),f.match(/YMax$/)&&("meet"==c&&p==d||"slice"==c&&g==d)&&e.translate(0,s-r)),"none"==f?e.scale(d,m):"meet"==c?e.scale(p,p):"slice"==c&&e.scale(g,g),e.translate(null==o?0:-o,null==l?0:-l)},t.Element={},t.EmptyProperty=new t.Property("EMPTY",""),t.Element.ElementBase=function(e){if(this.attributes={},this.styles={},this.children=[],this.attribute=function(e,i){var n=this.attributes[e];return null!=n?n:(1==i&&(n=new t.Property(e,""),this.attributes[e]=n),n||t.EmptyProperty)},this.getHrefAttribute=function(){for(var e in this.attributes)if(e.match(/:href$/))return this.attributes[e];return t.EmptyProperty},this.style=function(e,i){var n=this.styles[e];if(null!=n)return n;var a=this.attribute(e);if(null!=a&&a.hasValue())return this.styles[e]=a,a;var s=this.parent;if(null!=s){var r=s.style(e);if(null!=r&&r.hasValue())return r}return 1==i&&(n=new t.Property(e,""),this.styles[e]=n),n||t.EmptyProperty},this.render=function(t){if("none"!=this.style("display").value&&"hidden"!=this.attribute("visibility").value){if(t.save(),this.attribute("mask").hasValue()){var e=this.attribute("mask").getDefinition();null!=e&&e.apply(t,this)}else if(this.style("filter").hasValue()){var i=this.style("filter").getDefinition();null!=i&&i.apply(t,this)}else this.setContext(t),this.renderChildren(t),this.clearContext(t);t.restore()}},this.setContext=function(t){},this.clearContext=function(t){},this.renderChildren=function(t){for(var e=0;e<this.children.length;e++)this.children[e].render(t)},this.addChild=function(e,i){var n=e;i&&(n=t.CreateElement(e)),n.parent=this,this.children.push(n)},null!=e&&1==e.nodeType){for(var i=0;i<e.childNodes.length;i++){var n=e.childNodes[i];if(1==n.nodeType&&this.addChild(n,!0),this.captureTextNodes&&3==n.nodeType){var a=n.nodeValue||n.text||"";""!=t.trim(t.compressSpaces(a))&&this.addChild(new t.Element.tspan(n),!1)}}for(var i=0;i<e.attributes.length;i++){var s=e.attributes[i];this.attributes[s.nodeName]=new t.Property(s.nodeName,s.nodeValue)}var r=t.Styles[e.nodeName];if(null!=r)for(var o in r)this.styles[o]=r[o];if(this.attribute("class").hasValue())for(var l=t.compressSpaces(this.attribute("class").value).split(" "),h=0;h<l.length;h++){if(null!=(r=t.Styles["."+l[h]]))for(var o in r)this.styles[o]=r[o];if(null!=(r=t.Styles[e.nodeName+"."+l[h]]))for(var o in r)this.styles[o]=r[o]}if(this.attribute("id").hasValue()){var r=t.Styles["#"+this.attribute("id").value];if(null!=r)for(var o in r)this.styles[o]=r[o]}if(this.attribute("style").hasValue())for(var r=this.attribute("style").value.split(";"),i=0;i<r.length;i++)if(""!=t.trim(r[i])){var u=r[i].split(":"),o=t.trim(u[0]),f=t.trim(u[1]);this.styles[o]=new t.Property(o,f)}this.attribute("id").hasValue()&&null==t.Definitions[this.attribute("id").value]&&(t.Definitions[this.attribute("id").value]=this)}},t.Element.RenderedElementBase=function(e){this.base=t.Element.ElementBase,this.base(e),this.setContext=function(e){if(this.style("fill").isUrlDefinition()){var i=this.style("fill").getFillStyleDefinition(this,this.style("fill-opacity"));null!=i&&(e.fillStyle=i)}else if(this.style("fill").hasValue()){var n=this.style("fill");"currentColor"==n.value&&(n.value=this.style("color").value),e.fillStyle="none"==n.value?"rgba(0,0,0,0)":n.value}if(this.style("fill-opacity").hasValue()){var n=new t.Property("fill",e.fillStyle);n=n.addOpacity(this.style("fill-opacity").value),e.fillStyle=n.value}if(this.style("stroke").isUrlDefinition()){var i=this.style("stroke").getFillStyleDefinition(this,this.style("stroke-opacity"));null!=i&&(e.strokeStyle=i)}else if(this.style("stroke").hasValue()){var a=this.style("stroke");"currentColor"==a.value&&(a.value=this.style("color").value),e.strokeStyle="none"==a.value?"rgba(0,0,0,0)":a.value}if(this.style("stroke-opacity").hasValue()){var a=new t.Property("stroke",e.strokeStyle);a=a.addOpacity(this.style("stroke-opacity").value),e.strokeStyle=a.value}if(this.style("stroke-width").hasValue()){var s=this.style("stroke-width").toPixels();e.lineWidth=0==s?.001:s}if(this.style("stroke-linecap").hasValue()&&(e.lineCap=this.style("stroke-linecap").value),this.style("stroke-linejoin").hasValue()&&(e.lineJoin=this.style("stroke-linejoin").value),this.style("stroke-miterlimit").hasValue()&&(e.miterLimit=this.style("stroke-miterlimit").value),this.style("stroke-dasharray").hasValue()){var r=t.ToNumberArray(this.style("stroke-dasharray").value);void 0!==e.setLineDash?e.setLineDash(r):void 0!==e.webkitLineDash?e.webkitLineDash=r:void 0!==e.mozDash&&(e.mozDash=r);var o=this.style("stroke-dashoffset").numValueOrDefault(1);void 0!==e.lineDashOffset?e.lineDashOffset=o:void 0!==e.webkitLineDashOffset?e.webkitLineDashOffset=o:void 0!==e.mozDashOffset&&(e.mozDashOffset=o)}if(void 0!==e.font&&(e.font=t.Font.CreateFont(this.style("font-style").value,this.style("font-variant").value,this.style("font-weight").value,this.style("font-size").hasValue()?this.style("font-size").toPixels()+"px":"",this.style("font-family").value).toString()),this.attribute("transform").hasValue()){new t.Transform(this.attribute("transform").value).apply(e)}if(this.style("clip-path").hasValue()){var l=this.style("clip-path").getDefinition();null!=l&&l.apply(e)}this.style("opacity").hasValue()&&(e.globalAlpha=this.style("opacity").numValue())}},t.Element.RenderedElementBase.prototype=new t.Element.ElementBase,t.Element.PathElementBase=function(e){this.base=t.Element.RenderedElementBase,this.base(e),this.path=function(e){return null!=e&&e.beginPath(),new t.BoundingBox},this.renderChildren=function(e){this.path(e),t.Mouse.checkPath(this,e),""!=e.fillStyle&&(this.attribute("fill-rule").hasValue()?e.fill(this.attribute("fill-rule").value):e.fill()),""!=e.strokeStyle&&e.stroke();var i=this.getMarkers();if(null!=i){if(this.style("marker-start").isUrlDefinition()){var n=this.style("marker-start").getDefinition();n.render(e,i[0][0],i[0][1])}if(this.style("marker-mid").isUrlDefinition())for(var n=this.style("marker-mid").getDefinition(),a=1;a<i.length-1;a++)n.render(e,i[a][0],i[a][1]);if(this.style("marker-end").isUrlDefinition()){var n=this.style("marker-end").getDefinition();n.render(e,i[i.length-1][0],i[i.length-1][1])}}},this.getBoundingBox=function(){return this.path()},this.getMarkers=function(){return null}},t.Element.PathElementBase.prototype=new t.Element.RenderedElementBase,t.Element.svg=function(e){this.base=t.Element.RenderedElementBase,this.base(e),this.baseClearContext=this.clearContext,this.clearContext=function(e){this.baseClearContext(e),t.ViewPort.RemoveCurrent()},this.baseSetContext=this.setContext,this.setContext=function(e){e.strokeStyle="rgba(0,0,0,0)",e.lineCap="butt",e.lineJoin="miter",e.miterLimit=4,this.baseSetContext(e),this.attribute("x").hasValue()||(this.attribute("x",!0).value=0),this.attribute("y").hasValue()||(this.attribute("y",!0).value=0),e.translate(this.attribute("x").toPixels("x"),this.attribute("y").toPixels("y"));var i=t.ViewPort.width(),n=t.ViewPort.height();if(this.attribute("width").hasValue()||(this.attribute("width",!0).value="100%"),this.attribute("height").hasValue()||(this.attribute("height",!0).value="100%"),void 0===this.root){i=this.attribute("width").toPixels("x"),n=this.attribute("height").toPixels("y");var a=0,s=0;this.attribute("refX").hasValue()&&this.attribute("refY").hasValue()&&(a=-this.attribute("refX").toPixels("x"),s=-this.attribute("refY").toPixels("y")),e.beginPath(),e.moveTo(a,s),e.lineTo(i,s),e.lineTo(i,n),e.lineTo(a,n),e.closePath(),e.clip()}if(t.ViewPort.SetCurrent(i,n),this.attribute("viewBox").hasValue()){var r=t.ToNumberArray(this.attribute("viewBox").value),o=r[0],l=r[1];i=r[2],n=r[3],t.AspectRatio(e,this.attribute("preserveAspectRatio").value,t.ViewPort.width(),i,t.ViewPort.height(),n,o,l,this.attribute("refX").value,this.attribute("refY").value),t.ViewPort.RemoveCurrent(),t.ViewPort.SetCurrent(r[2],r[3])}}},t.Element.svg.prototype=new t.Element.RenderedElementBase,t.Element.rect=function(e){this.base=t.Element.PathElementBase,this.base(e),this.path=function(e){var i=this.attribute("x").toPixels("x"),n=this.attribute("y").toPixels("y"),a=this.attribute("width").toPixels("x"),s=this.attribute("height").toPixels("y"),r=this.attribute("rx").toPixels("x"),o=this.attribute("ry").toPixels("y");return this.attribute("rx").hasValue()&&!this.attribute("ry").hasValue()&&(o=r),this.attribute("ry").hasValue()&&!this.attribute("rx").hasValue()&&(r=o),r=Math.min(r,a/2),o=Math.min(o,s/2),null!=e&&(e.beginPath(),e.moveTo(i+r,n),e.lineTo(i+a-r,n),e.quadraticCurveTo(i+a,n,i+a,n+o),e.lineTo(i+a,n+s-o),e.quadraticCurveTo(i+a,n+s,i+a-r,n+s),e.lineTo(i+r,n+s),e.quadraticCurveTo(i,n+s,i,n+s-o),e.lineTo(i,n+o),e.quadraticCurveTo(i,n,i+r,n),e.closePath()),new t.BoundingBox(i,n,i+a,n+s)}},t.Element.rect.prototype=new t.Element.PathElementBase,t.Element.circle=function(e){this.base=t.Element.PathElementBase,this.base(e),this.path=function(e){var i=this.attribute("cx").toPixels("x"),n=this.attribute("cy").toPixels("y"),a=this.attribute("r").toPixels();return null!=e&&(e.beginPath(),e.arc(i,n,a,0,2*Math.PI,!0),e.closePath()),new t.BoundingBox(i-a,n-a,i+a,n+a)}},t.Element.circle.prototype=new t.Element.PathElementBase,t.Element.ellipse=function(e){this.base=t.Element.PathElementBase,this.base(e),this.path=function(e){var i=(Math.sqrt(2)-1)/3*4,n=this.attribute("rx").toPixels("x"),a=this.attribute("ry").toPixels("y"),s=this.attribute("cx").toPixels("x"),r=this.attribute("cy").toPixels("y");return null!=e&&(e.beginPath(),e.moveTo(s,r-a),e.bezierCurveTo(s+i*n,r-a,s+n,r-i*a,s+n,r),e.bezierCurveTo(s+n,r+i*a,s+i*n,r+a,s,r+a),e.bezierCurveTo(s-i*n,r+a,s-n,r+i*a,s-n,r),e.bezierCurveTo(s-n,r-i*a,s-i*n,r-a,s,r-a),e.closePath()),new t.BoundingBox(s-n,r-a,s+n,r+a)}},t.Element.ellipse.prototype=new t.Element.PathElementBase,t.Element.line=function(e){this.base=t.Element.PathElementBase,this.base(e),this.getPoints=function(){return[new t.Point(this.attribute("x1").toPixels("x"),this.attribute("y1").toPixels("y")),new t.Point(this.attribute("x2").toPixels("x"),this.attribute("y2").toPixels("y"))]},this.path=function(e){var i=this.getPoints();return null!=e&&(e.beginPath(),e.moveTo(i[0].x,i[0].y),e.lineTo(i[1].x,i[1].y)),new t.BoundingBox(i[0].x,i[0].y,i[1].x,i[1].y)},this.getMarkers=function(){var t=this.getPoints(),e=t[0].angleTo(t[1]);return[[t[0],e],[t[1],e]]}},t.Element.line.prototype=new t.Element.PathElementBase,t.Element.polyline=function(e){this.base=t.Element.PathElementBase,this.base(e),this.points=t.CreatePath(this.attribute("points").value),this.path=function(e){var i=new t.BoundingBox(this.points[0].x,this.points[0].y);null!=e&&(e.beginPath(),e.moveTo(this.points[0].x,this.points[0].y))
;for(var n=1;n<this.points.length;n++)i.addPoint(this.points[n].x,this.points[n].y),null!=e&&e.lineTo(this.points[n].x,this.points[n].y);return i},this.getMarkers=function(){for(var t=[],e=0;e<this.points.length-1;e++)t.push([this.points[e],this.points[e].angleTo(this.points[e+1])]);return t.push([this.points[this.points.length-1],t[t.length-1][1]]),t}},t.Element.polyline.prototype=new t.Element.PathElementBase,t.Element.polygon=function(e){this.base=t.Element.polyline,this.base(e),this.basePath=this.path,this.path=function(t){var e=this.basePath(t);return null!=t&&(t.lineTo(this.points[0].x,this.points[0].y),t.closePath()),e}},t.Element.polygon.prototype=new t.Element.polyline,t.Element.path=function(e){this.base=t.Element.PathElementBase,this.base(e);var i=this.attribute("d").value;i=i.replace(/,/gm," "),i=i.replace(/([MmZzLlHhVvCcSsQqTtAa])([MmZzLlHhVvCcSsQqTtAa])/gm,"$1 $2"),i=i.replace(/([MmZzLlHhVvCcSsQqTtAa])([MmZzLlHhVvCcSsQqTtAa])/gm,"$1 $2"),i=i.replace(/([MmZzLlHhVvCcSsQqTtAa])([^\s])/gm,"$1 $2"),i=i.replace(/([^\s])([MmZzLlHhVvCcSsQqTtAa])/gm,"$1 $2"),i=i.replace(/([0-9])([+\-])/gm,"$1 $2"),i=i.replace(/(\.[0-9]*)(\.)/gm,"$1 $2"),i=i.replace(/([Aa](\s+[0-9]+){3})\s+([01])\s*([01])/gm,"$1 $3 $4 "),i=t.compressSpaces(i),i=t.trim(i),this.PathParser=new function(e){this.tokens=e.split(" "),this.reset=function(){this.i=-1,this.command="",this.previousCommand="",this.start=new t.Point(0,0),this.control=new t.Point(0,0),this.current=new t.Point(0,0),this.points=[],this.angles=[]},this.isEnd=function(){return this.i>=this.tokens.length-1},this.isCommandOrEnd=function(){return!!this.isEnd()||null!=this.tokens[this.i+1].match(/^[A-Za-z]$/)},this.isRelativeCommand=function(){switch(this.command){case"m":case"l":case"h":case"v":case"c":case"s":case"q":case"t":case"a":case"z":return!0}return!1},this.getToken=function(){return this.i++,this.tokens[this.i]},this.getScalar=function(){return parseFloat(this.getToken())},this.nextCommand=function(){this.previousCommand=this.command,this.command=this.getToken()},this.getPoint=function(){var e=new t.Point(this.getScalar(),this.getScalar());return this.makeAbsolute(e)},this.getAsControlPoint=function(){var t=this.getPoint();return this.control=t,t},this.getAsCurrentPoint=function(){var t=this.getPoint();return this.current=t,t},this.getReflectedControlPoint=function(){return"c"!=this.previousCommand.toLowerCase()&&"s"!=this.previousCommand.toLowerCase()&&"q"!=this.previousCommand.toLowerCase()&&"t"!=this.previousCommand.toLowerCase()?this.current:new t.Point(2*this.current.x-this.control.x,2*this.current.y-this.control.y)},this.makeAbsolute=function(t){return this.isRelativeCommand()&&(t.x+=this.current.x,t.y+=this.current.y),t},this.addMarker=function(t,e,i){null!=i&&this.angles.length>0&&null==this.angles[this.angles.length-1]&&(this.angles[this.angles.length-1]=this.points[this.points.length-1].angleTo(i)),this.addMarkerAngle(t,null==e?null:e.angleTo(t))},this.addMarkerAngle=function(t,e){this.points.push(t),this.angles.push(e)},this.getMarkerPoints=function(){return this.points},this.getMarkerAngles=function(){for(var t=0;t<this.angles.length;t++)if(null==this.angles[t])for(var e=t+1;e<this.angles.length;e++)if(null!=this.angles[e]){this.angles[t]=this.angles[e];break}return this.angles}}(i),this.path=function(e){var i=this.PathParser;i.reset();var n=new t.BoundingBox;for(null!=e&&e.beginPath();!i.isEnd();)switch(i.nextCommand(),i.command){case"M":case"m":var a=i.getAsCurrentPoint();for(i.addMarker(a),n.addPoint(a.x,a.y),null!=e&&e.moveTo(a.x,a.y),i.start=i.current;!i.isCommandOrEnd();){var a=i.getAsCurrentPoint();i.addMarker(a,i.start),n.addPoint(a.x,a.y),null!=e&&e.lineTo(a.x,a.y)}break;case"L":case"l":for(;!i.isCommandOrEnd();){var s=i.current,a=i.getAsCurrentPoint();i.addMarker(a,s),n.addPoint(a.x,a.y),null!=e&&e.lineTo(a.x,a.y)}break;case"H":case"h":for(;!i.isCommandOrEnd();){var r=new t.Point((i.isRelativeCommand()?i.current.x:0)+i.getScalar(),i.current.y);i.addMarker(r,i.current),i.current=r,n.addPoint(i.current.x,i.current.y),null!=e&&e.lineTo(i.current.x,i.current.y)}break;case"V":case"v":for(;!i.isCommandOrEnd();){var r=new t.Point(i.current.x,(i.isRelativeCommand()?i.current.y:0)+i.getScalar());i.addMarker(r,i.current),i.current=r,n.addPoint(i.current.x,i.current.y),null!=e&&e.lineTo(i.current.x,i.current.y)}break;case"C":case"c":for(;!i.isCommandOrEnd();){var o=i.current,l=i.getPoint(),h=i.getAsControlPoint(),u=i.getAsCurrentPoint();i.addMarker(u,h,l),n.addBezierCurve(o.x,o.y,l.x,l.y,h.x,h.y,u.x,u.y),null!=e&&e.bezierCurveTo(l.x,l.y,h.x,h.y,u.x,u.y)}break;case"S":case"s":for(;!i.isCommandOrEnd();){var o=i.current,l=i.getReflectedControlPoint(),h=i.getAsControlPoint(),u=i.getAsCurrentPoint();i.addMarker(u,h,l),n.addBezierCurve(o.x,o.y,l.x,l.y,h.x,h.y,u.x,u.y),null!=e&&e.bezierCurveTo(l.x,l.y,h.x,h.y,u.x,u.y)}break;case"Q":case"q":for(;!i.isCommandOrEnd();){var o=i.current,h=i.getAsControlPoint(),u=i.getAsCurrentPoint();i.addMarker(u,h,h),n.addQuadraticCurve(o.x,o.y,h.x,h.y,u.x,u.y),null!=e&&e.quadraticCurveTo(h.x,h.y,u.x,u.y)}break;case"T":case"t":for(;!i.isCommandOrEnd();){var o=i.current,h=i.getReflectedControlPoint();i.control=h;var u=i.getAsCurrentPoint();i.addMarker(u,h,h),n.addQuadraticCurve(o.x,o.y,h.x,h.y,u.x,u.y),null!=e&&e.quadraticCurveTo(h.x,h.y,u.x,u.y)}break;case"A":case"a":for(;!i.isCommandOrEnd();){var o=i.current,f=i.getScalar(),c=i.getScalar(),d=i.getScalar()*(Math.PI/180),m=i.getScalar(),p=i.getScalar(),u=i.getAsCurrentPoint(),g=new t.Point(Math.cos(d)*(o.x-u.x)/2+Math.sin(d)*(o.y-u.y)/2,-Math.sin(d)*(o.x-u.x)/2+Math.cos(d)*(o.y-u.y)/2),y=Math.pow(g.x,2)/Math.pow(f,2)+Math.pow(g.y,2)/Math.pow(c,2);y>1&&(f*=Math.sqrt(y),c*=Math.sqrt(y));var v=(m==p?-1:1)*Math.sqrt((Math.pow(f,2)*Math.pow(c,2)-Math.pow(f,2)*Math.pow(g.y,2)-Math.pow(c,2)*Math.pow(g.x,2))/(Math.pow(f,2)*Math.pow(g.y,2)+Math.pow(c,2)*Math.pow(g.x,2)));isNaN(v)&&(v=0);var b=new t.Point(v*f*g.y/c,v*-c*g.x/f),x=new t.Point((o.x+u.x)/2+Math.cos(d)*b.x-Math.sin(d)*b.y,(o.y+u.y)/2+Math.sin(d)*b.x+Math.cos(d)*b.y),w=function(t){return Math.sqrt(Math.pow(t[0],2)+Math.pow(t[1],2))},E=function(t,e){return(t[0]*e[0]+t[1]*e[1])/(w(t)*w(e))},P=function(t,e){return(t[0]*e[1]<t[1]*e[0]?-1:1)*Math.acos(E(t,e))},B=P([1,0],[(g.x-b.x)/f,(g.y-b.y)/c]),C=[(g.x-b.x)/f,(g.y-b.y)/c],V=[(-g.x-b.x)/f,(-g.y-b.y)/c],k=P(C,V);E(C,V)<=-1&&(k=Math.PI),E(C,V)>=1&&(k=0);var T=1-p?1:-1,M=B+T*(k/2),S=new t.Point(x.x+f*Math.cos(M),x.y+c*Math.sin(M));if(i.addMarkerAngle(S,M-T*Math.PI/2),i.addMarkerAngle(u,M-T*Math.PI),n.addPoint(u.x,u.y),null!=e){var E=f>c?f:c,A=f>c?1:f/c,R=f>c?c/f:1;e.translate(x.x,x.y),e.rotate(d),e.scale(A,R),e.arc(0,0,E,B,B+k,1-p),e.scale(1/A,1/R),e.rotate(-d),e.translate(-x.x,-x.y)}}break;case"Z":case"z":null!=e&&e.closePath(),i.current=i.start}return n},this.getMarkers=function(){for(var t=this.PathParser.getMarkerPoints(),e=this.PathParser.getMarkerAngles(),i=[],n=0;n<t.length;n++)i.push([t[n],e[n]]);return i}},t.Element.path.prototype=new t.Element.PathElementBase,t.Element.pattern=function(e){this.base=t.Element.ElementBase,this.base(e),this.createPattern=function(e,i){var n=this.attribute("width").toPixels("x",!0),a=this.attribute("height").toPixels("y",!0),s=new t.Element.svg;s.attributes.viewBox=new t.Property("viewBox",this.attribute("viewBox").value),s.attributes.width=new t.Property("width",n+"px"),s.attributes.height=new t.Property("height",a+"px"),s.attributes.transform=new t.Property("transform",this.attribute("patternTransform").value),s.children=this.children;var r=document.createElement("canvas");r.width=n,r.height=a;var o=r.getContext("2d");this.attribute("x").hasValue()&&this.attribute("y").hasValue()&&o.translate(this.attribute("x").toPixels("x",!0),this.attribute("y").toPixels("y",!0));for(var l=-1;l<=1;l++)for(var h=-1;h<=1;h++)o.save(),o.translate(l*r.width,h*r.height),s.render(o),o.restore();return e.createPattern(r,"repeat")}},t.Element.pattern.prototype=new t.Element.ElementBase,t.Element.marker=function(e){this.base=t.Element.ElementBase,this.base(e),this.baseRender=this.render,this.render=function(e,i,n){e.translate(i.x,i.y),"auto"==this.attribute("orient").valueOrDefault("auto")&&e.rotate(n),"strokeWidth"==this.attribute("markerUnits").valueOrDefault("strokeWidth")&&e.scale(e.lineWidth,e.lineWidth),e.save();var a=new t.Element.svg;a.attributes.viewBox=new t.Property("viewBox",this.attribute("viewBox").value),a.attributes.refX=new t.Property("refX",this.attribute("refX").value),a.attributes.refY=new t.Property("refY",this.attribute("refY").value),a.attributes.width=new t.Property("width",this.attribute("markerWidth").value),a.attributes.height=new t.Property("height",this.attribute("markerHeight").value),a.attributes.fill=new t.Property("fill",this.attribute("fill").valueOrDefault("black")),a.attributes.stroke=new t.Property("stroke",this.attribute("stroke").valueOrDefault("none")),a.children=this.children,a.render(e),e.restore(),"strokeWidth"==this.attribute("markerUnits").valueOrDefault("strokeWidth")&&e.scale(1/e.lineWidth,1/e.lineWidth),"auto"==this.attribute("orient").valueOrDefault("auto")&&e.rotate(-n),e.translate(-i.x,-i.y)}},t.Element.marker.prototype=new t.Element.ElementBase,t.Element.defs=function(e){this.base=t.Element.ElementBase,this.base(e),this.render=function(t){}},t.Element.defs.prototype=new t.Element.ElementBase,t.Element.GradientBase=function(e){this.base=t.Element.ElementBase,this.base(e),this.gradientUnits=this.attribute("gradientUnits").valueOrDefault("objectBoundingBox"),this.stops=[];for(var i=0;i<this.children.length;i++){var n=this.children[i];"stop"==n.type&&this.stops.push(n)}this.getGradient=function(){},this.createGradient=function(e,i,n){var a=this;this.getHrefAttribute().hasValue()&&(a=this.getHrefAttribute().getDefinition());var s=function(e){if(n.hasValue()){return new t.Property("color",e).addOpacity(n.value).value}return e},r=this.getGradient(e,i);if(null==r)return s(a.stops[a.stops.length-1].color);for(var o=0;o<a.stops.length;o++)r.addColorStop(a.stops[o].offset,s(a.stops[o].color));if(this.attribute("gradientTransform").hasValue()){var l=t.ViewPort.viewPorts[0],h=new t.Element.rect;h.attributes.x=new t.Property("x",-t.MAX_VIRTUAL_PIXELS/3),h.attributes.y=new t.Property("y",-t.MAX_VIRTUAL_PIXELS/3),h.attributes.width=new t.Property("width",t.MAX_VIRTUAL_PIXELS),h.attributes.height=new t.Property("height",t.MAX_VIRTUAL_PIXELS);var u=new t.Element.g;u.attributes.transform=new t.Property("transform",this.attribute("gradientTransform").value),u.children=[h];var f=new t.Element.svg;f.attributes.x=new t.Property("x",0),f.attributes.y=new t.Property("y",0),f.attributes.width=new t.Property("width",l.width),f.attributes.height=new t.Property("height",l.height),f.children=[u];var c=document.createElement("canvas");c.width=l.width,c.height=l.height;var d=c.getContext("2d");return d.fillStyle=r,f.render(d),d.createPattern(c,"no-repeat")}return r}},t.Element.GradientBase.prototype=new t.Element.ElementBase,t.Element.linearGradient=function(e){this.base=t.Element.GradientBase,this.base(e),this.getGradient=function(t,e){var i=e.getBoundingBox();this.attribute("x1").hasValue()||this.attribute("y1").hasValue()||this.attribute("x2").hasValue()||this.attribute("y2").hasValue()||(this.attribute("x1",!0).value=0,this.attribute("y1",!0).value=0,this.attribute("x2",!0).value=1,this.attribute("y2",!0).value=0);var n="objectBoundingBox"==this.gradientUnits?i.x()+i.width()*this.attribute("x1").numValue():this.attribute("x1").toPixels("x"),a="objectBoundingBox"==this.gradientUnits?i.y()+i.height()*this.attribute("y1").numValue():this.attribute("y1").toPixels("y"),s="objectBoundingBox"==this.gradientUnits?i.x()+i.width()*this.attribute("x2").numValue():this.attribute("x2").toPixels("x"),r="objectBoundingBox"==this.gradientUnits?i.y()+i.height()*this.attribute("y2").numValue():this.attribute("y2").toPixels("y");return n==s&&a==r?null:t.createLinearGradient(n,a,s,r)}},t.Element.linearGradient.prototype=new t.Element.GradientBase,t.Element.radialGradient=function(e){this.base=t.Element.GradientBase,this.base(e),this.getGradient=function(t,e){var i=e.getBoundingBox();this.attribute("cx").hasValue()||(this.attribute("cx",!0).value="50%"),this.attribute("cy").hasValue()||(this.attribute("cy",!0).value="50%"),this.attribute("r").hasValue()||(this.attribute("r",!0).value="50%");var n="objectBoundingBox"==this.gradientUnits?i.x()+i.width()*this.attribute("cx").numValue():this.attribute("cx").toPixels("x"),a="objectBoundingBox"==this.gradientUnits?i.y()+i.height()*this.attribute("cy").numValue():this.attribute("cy").toPixels("y"),s=n,r=a;this.attribute("fx").hasValue()&&(s="objectBoundingBox"==this.gradientUnits?i.x()+i.width()*this.attribute("fx").numValue():this.attribute("fx").toPixels("x")),this.attribute("fy").hasValue()&&(r="objectBoundingBox"==this.gradientUnits?i.y()+i.height()*this.attribute("fy").numValue():this.attribute("fy").toPixels("y"));var o="objectBoundingBox"==this.gradientUnits?(i.width()+i.height())/2*this.attribute("r").numValue():this.attribute("r").toPixels();return t.createRadialGradient(s,r,0,n,a,o)}},t.Element.radialGradient.prototype=new t.Element.GradientBase,t.Element.stop=function(e){this.base=t.Element.ElementBase,this.base(e),this.offset=this.attribute("offset").numValue(),this.offset<0&&(this.offset=0),this.offset>1&&(this.offset=1);var i=this.style("stop-color");this.style("stop-opacity").hasValue()&&(i=i.addOpacity(this.style("stop-opacity").value)),this.color=i.value},t.Element.stop.prototype=new t.Element.ElementBase,t.Element.AnimateBase=function(e){this.base=t.Element.ElementBase,this.base(e),t.Animations.push(this),this.duration=0,this.begin=this.attribute("begin").toMilliseconds(),this.maxDuration=this.begin+this.attribute("dur").toMilliseconds(),this.getProperty=function(){var t=this.attribute("attributeType").value,e=this.attribute("attributeName").value;return"CSS"==t?this.parent.style(e,!0):this.parent.attribute(e,!0)},this.initialValue=null,this.initialUnits="",this.removed=!1,this.calcValue=function(){return""},this.update=function(t){if(null==this.initialValue&&(this.initialValue=this.getProperty().value,this.initialUnits=this.getProperty().getUnits()),this.duration>this.maxDuration){if("indefinite"!=this.attribute("repeatCount").value&&"indefinite"!=this.attribute("repeatDur").value)return"remove"==this.attribute("fill").valueOrDefault("remove")&&!this.removed&&(this.removed=!0,this.getProperty().value=this.initialValue,!0);this.duration=0}this.duration=this.duration+t;var e=!1;if(this.begin<this.duration){var i=this.calcValue();if(this.attribute("type").hasValue()){i=this.attribute("type").value+"("+i+")"}this.getProperty().value=i,e=!0}return e},this.from=this.attribute("from"),this.to=this.attribute("to"),this.values=this.attribute("values"),this.values.hasValue()&&(this.values.value=this.values.value.split(";")),this.progress=function(){var e={progress:(this.duration-this.begin)/(this.maxDuration-this.begin)};if(this.values.hasValue()){var i=e.progress*(this.values.value.length-1),n=Math.floor(i),a=Math.ceil(i);e.from=new t.Property("from",parseFloat(this.values.value[n])),e.to=new t.Property("to",parseFloat(this.values.value[a])),e.progress=(i-n)/(a-n)}else e.from=this.from,e.to=this.to;return e}},t.Element.AnimateBase.prototype=new t.Element.ElementBase,t.Element.animate=function(e){this.base=t.Element.AnimateBase,this.base(e),this.calcValue=function(){var t=this.progress();return t.from.numValue()+(t.to.numValue()-t.from.numValue())*t.progress+this.initialUnits}},t.Element.animate.prototype=new t.Element.AnimateBase,t.Element.animateColor=function(e){this.base=t.Element.AnimateBase,this.base(e),this.calcValue=function(){var t=this.progress(),e=new RGBColor(t.from.value),i=new RGBColor(t.to.value);if(e.ok&&i.ok){var n=e.r+(i.r-e.r)*t.progress,a=e.g+(i.g-e.g)*t.progress,s=e.b+(i.b-e.b)*t.progress;return"rgb("+parseInt(n,10)+","+parseInt(a,10)+","+parseInt(s,10)+")"}return this.attribute("from").value}},t.Element.animateColor.prototype=new t.Element.AnimateBase,t.Element.animateTransform=function(e){this.base=t.Element.AnimateBase,this.base(e),this.calcValue=function(){for(var e=this.progress(),i=t.ToNumberArray(e.from.value),n=t.ToNumberArray(e.to.value),a="",s=0;s<i.length;s++)a+=i[s]+(n[s]-i[s])*e.progress+" ";return a}},t.Element.animateTransform.prototype=new t.Element.animate,t.Element.font=function(e){this.base=t.Element.ElementBase,this.base(e),this.horizAdvX=this.attribute("horiz-adv-x").numValue(),this.isRTL=!1,this.isArabic=!1,this.fontFace=null,this.missingGlyph=null,this.glyphs=[];for(var i=0;i<this.children.length;i++){var n=this.children[i];"font-face"==n.type?(this.fontFace=n,n.style("font-family").hasValue()&&(t.Definitions[n.style("font-family").value]=this)):"missing-glyph"==n.type?this.missingGlyph=n:"glyph"==n.type&&(""!=n.arabicForm?(this.isRTL=!0,this.isArabic=!0,void 0===this.glyphs[n.unicode]&&(this.glyphs[n.unicode]=[]),this.glyphs[n.unicode][n.arabicForm]=n):this.glyphs[n.unicode]=n)}},t.Element.font.prototype=new t.Element.ElementBase,t.Element.fontface=function(e){this.base=t.Element.ElementBase,this.base(e),this.ascent=this.attribute("ascent").value,this.descent=this.attribute("descent").value,this.unitsPerEm=this.attribute("units-per-em").numValue()},t.Element.fontface.prototype=new t.Element.ElementBase,t.Element.missingglyph=function(e){this.base=t.Element.path,this.base(e),this.horizAdvX=0},t.Element.missingglyph.prototype=new t.Element.path,t.Element.glyph=function(e){this.base=t.Element.path,this.base(e),this.horizAdvX=this.attribute("horiz-adv-x").numValue(),this.unicode=this.attribute("unicode").value,this.arabicForm=this.attribute("arabic-form").value},t.Element.glyph.prototype=new t.Element.path,t.Element.text=function(e){this.captureTextNodes=!0,this.base=t.Element.RenderedElementBase,this.base(e),this.baseSetContext=this.setContext,this.setContext=function(t){this.baseSetContext(t),this.style("dominant-baseline").hasValue()&&(t.textBaseline=this.style("dominant-baseline").value),this.style("alignment-baseline").hasValue()&&(t.textBaseline=this.style("alignment-baseline").value)},this.getBoundingBox=function(){return new t.BoundingBox(this.attribute("x").toPixels("x"),this.attribute("y").toPixels("y"),0,0)},this.renderChildren=function(t){this.x=this.attribute("x").toPixels("x"),this.y=this.attribute("y").toPixels("y"),this.x+=this.getAnchorDelta(t,this,0);for(var e=0;e<this.children.length;e++)this.renderChild(t,this,e)},this.getAnchorDelta=function(t,e,i){var n=this.style("text-anchor").valueOrDefault("start");if("start"!=n){for(var a=0,s=i;s<e.children.length;s++){var r=e.children[s];if(s>i&&r.attribute("x").hasValue())break;a+=r.measureTextRecursive(t)}return-1*("end"==n?a:a/2)}return 0},this.renderChild=function(t,e,i){var n=e.children[i];n.attribute("x").hasValue()?n.x=n.attribute("x").toPixels("x")+this.getAnchorDelta(t,e,i):(this.attribute("dx").hasValue()&&(this.x+=this.attribute("dx").toPixels("x")),n.attribute("dx").hasValue()&&(this.x+=n.attribute("dx").toPixels("x")),n.x=this.x),this.x=n.x+n.measureText(t),n.attribute("y").hasValue()?n.y=n.attribute("y").toPixels("y"):(this.attribute("dy").hasValue()&&(this.y+=this.attribute("dy").toPixels("y")),n.attribute("dy").hasValue()&&(this.y+=n.attribute("dy").toPixels("y")),n.y=this.y),this.y=n.y,n.render(t);for(var i=0;i<n.children.length;i++)this.renderChild(t,n,i)}},t.Element.text.prototype=new t.Element.RenderedElementBase,t.Element.TextElementBase=function(e){this.base=t.Element.RenderedElementBase,this.base(e),this.getGlyph=function(t,e,i){var n=e[i],a=null;if(t.isArabic){var s="isolated";(0==i||" "==e[i-1])&&i<e.length-2&&" "!=e[i+1]&&(s="terminal"),i>0&&" "!=e[i-1]&&i<e.length-2&&" "!=e[i+1]&&(s="medial"),i>0&&" "!=e[i-1]&&(i==e.length-1||" "==e[i+1])&&(s="initial"),void 0!==t.glyphs[n]&&null==(a=t.glyphs[n][s])&&"glyph"==t.glyphs[n].type&&(a=t.glyphs[n])}else a=t.glyphs[n];return null==a&&(a=t.missingGlyph),a},this.renderChildren=function(e){var i=this.parent.style("font-family").getDefinition();if(null==i)""!=e.fillStyle&&e.fillText(t.compressSpaces(this.getText()),this.x,this.y),""!=e.strokeStyle&&e.strokeText(t.compressSpaces(this.getText()),this.x,this.y);else{var n=this.parent.style("font-size").numValueOrDefault(t.Font.Parse(t.ctx.font).fontSize),a=this.parent.style("font-style").valueOrDefault(t.Font.Parse(t.ctx.font).fontStyle),s=this.getText();i.isRTL&&(s=s.split("").reverse().join(""));for(var r=t.ToNumberArray(this.parent.attribute("dx").value),o=0;o<s.length;o++){var l=this.getGlyph(i,s,o),h=n/i.fontFace.unitsPerEm;e.translate(this.x,this.y),e.scale(h,-h);var u=e.lineWidth;e.lineWidth=e.lineWidth*i.fontFace.unitsPerEm/n,"italic"==a&&e.transform(1,0,.4,1,0,0),l.render(e),"italic"==a&&e.transform(1,0,-.4,1,0,0),e.lineWidth=u,e.scale(1/h,-1/h),e.translate(-this.x,-this.y),this.x+=n*(l.horizAdvX||i.horizAdvX)/i.fontFace.unitsPerEm,void 0===r[o]||isNaN(r[o])||(this.x+=r[o])}}},this.getText=function(){},this.measureTextRecursive=function(t){for(var e=this.measureText(t),i=0;i<this.children.length;i++)e+=this.children[i].measureTextRecursive(t);return e},this.measureText=function(e){var i=this.parent.style("font-family").getDefinition();if(null!=i){var n=this.parent.style("font-size").numValueOrDefault(t.Font.Parse(t.ctx.font).fontSize),a=0,s=this.getText();i.isRTL&&(s=s.split("").reverse().join(""));for(var r=t.ToNumberArray(this.parent.attribute("dx").value),o=0;o<s.length;o++){a+=(this.getGlyph(i,s,o).horizAdvX||i.horizAdvX)*n/i.fontFace.unitsPerEm,void 0===r[o]||isNaN(r[o])||(a+=r[o])}return a}var l=t.compressSpaces(this.getText());if(!e.measureText)return 10*l.length;e.save(),this.setContext(e);var h=e.measureText(l).width;return e.restore(),h}},t.Element.TextElementBase.prototype=new t.Element.RenderedElementBase,t.Element.tspan=function(e){this.captureTextNodes=!0,this.base=t.Element.TextElementBase,this.base(e),this.text=e.nodeValue||e.text||"",this.getText=function(){return this.text}},t.Element.tspan.prototype=new t.Element.TextElementBase,t.Element.tref=function(e){this.base=t.Element.TextElementBase,this.base(e),this.getText=function(){var t=this.getHrefAttribute().getDefinition();if(null!=t)return t.children[0].getText()}},t.Element.tref.prototype=new t.Element.TextElementBase,t.Element.a=function(e){this.base=t.Element.TextElementBase,this.base(e),this.hasText=!0;for(var i=0;i<e.childNodes.length;i++)3!=e.childNodes[i].nodeType&&(this.hasText=!1);this.text=this.hasText?e.childNodes[0].nodeValue:"",this.getText=function(){return this.text},this.baseRenderChildren=this.renderChildren,this.renderChildren=function(e){if(this.hasText){this.baseRenderChildren(e);var i=new t.Property("fontSize",t.Font.Parse(t.ctx.font).fontSize);t.Mouse.checkBoundingBox(this,new t.BoundingBox(this.x,this.y-i.toPixels("y"),this.x+this.measureText(e),this.y))}else{var n=new t.Element.g;n.children=this.children,n.parent=this,n.render(e)}},this.onclick=function(){window.open(this.getHrefAttribute().value)},this.onmousemove=function(){t.ctx.canvas.style.cursor="pointer"}},t.Element.a.prototype=new t.Element.TextElementBase,t.Element.image=function(e){this.base=t.Element.RenderedElementBase,this.base(e);var i=this.getHrefAttribute().value,n=i.match(/\.svg$/);if(t.Images.push(this),this.loaded=!1,n)this.img=t.ajax(i),this.loaded=!0;else{this.img=document.createElement("img");var a=this;this.img.onload=function(){a.loaded=!0},this.img.onerror=function(){"undefined"!=typeof console&&(console.log('ERROR: image "'+i+'" not found'),a.loaded=!0)},this.img.src=i}this.renderChildren=function(e){var i=this.attribute("x").toPixels("x"),a=this.attribute("y").toPixels("y"),s=this.attribute("width").toPixels("x"),r=this.attribute("height").toPixels("y");0!=s&&0!=r&&(e.save(),n?e.drawSvg(this.img,i,a,s,r):(e.translate(i,a),t.AspectRatio(e,this.attribute("preserveAspectRatio").value,s,this.img.width,r,this.img.height,0,0),e.drawImage(this.img,0,0)),e.restore())},this.getBoundingBox=function(){var e=this.attribute("x").toPixels("x"),i=this.attribute("y").toPixels("y"),n=this.attribute("width").toPixels("x"),a=this.attribute("height").toPixels("y");return new t.BoundingBox(e,i,e+n,i+a)}},t.Element.image.prototype=new t.Element.RenderedElementBase,t.Element.g=function(e){this.base=t.Element.RenderedElementBase,this.base(e),this.getBoundingBox=function(){for(var e=new t.BoundingBox,i=0;i<this.children.length;i++)e.addBoundingBox(this.children[i].getBoundingBox());return e}},t.Element.g.prototype=new t.Element.RenderedElementBase,t.Element.symbol=function(e){this.base=t.Element.RenderedElementBase,this.base(e),this.baseSetContext=this.setContext,this.setContext=function(e){if(this.baseSetContext(e),this.attribute("viewBox").hasValue()){var i=t.ToNumberArray(this.attribute("viewBox").value),n=i[0],a=i[1];width=i[2],height=i[3],t.AspectRatio(e,this.attribute("preserveAspectRatio").value,this.attribute("width").toPixels("x"),width,this.attribute("height").toPixels("y"),height,n,a),t.ViewPort.SetCurrent(i[2],i[3])}}},t.Element.symbol.prototype=new t.Element.RenderedElementBase,t.Element.style=function(e){this.base=t.Element.ElementBase,this.base(e);for(var i="",n=0;n<e.childNodes.length;n++)i+=e.childNodes[n].nodeValue;i=i.replace(/(\/\*([^*]|[\r\n]|(\*+([^*\/]|[\r\n])))*\*+\/)|(^[\s]*\/\/.*)/gm,""),i=t.compressSpaces(i);for(var a=i.split("}"),n=0;n<a.length;n++)if(""!=t.trim(a[n]))for(var s=a[n].split("{"),r=s[0].split(","),o=s[1].split(";"),l=0;l<r.length;l++){var h=t.trim(r[l]);if(""!=h){for(var u={},f=0;f<o.length;f++){var c=o[f].indexOf(":"),d=o[f].substr(0,c),m=o[f].substr(c+1,o[f].length-c);null!=d&&null!=m&&(u[t.trim(d)]=new t.Property(t.trim(d),t.trim(m)))}if(t.Styles[h]=u,"@font-face"==h)for(var p=u["font-family"].value.replace(/"/g,""),g=u.src.value.split(","),y=0;y<g.length;y++)if(g[y].indexOf('format("svg")')>0)for(var v=g[y].indexOf("url"),b=g[y].indexOf(")",v),x=g[y].substr(v+5,b-v-6),w=t.parseXml(t.ajax(x)),E=w.getElementsByTagName("font"),P=0;P<E.length;P++){var B=t.CreateElement(E[P]);t.Definitions[p]=B}}}},t.Element.style.prototype=new t.Element.ElementBase,t.Element.use=function(e){this.base=t.Element.RenderedElementBase,this.base(e),this.baseSetContext=this.setContext,this.setContext=function(t){this.baseSetContext(t),this.attribute("x").hasValue()&&t.translate(this.attribute("x").toPixels("x"),0),this.attribute("y").hasValue()&&t.translate(0,this.attribute("y").toPixels("y"))},this.getDefinition=function(){var t=this.getHrefAttribute().getDefinition();return this.attribute("width").hasValue()&&(t.attribute("width",!0).value=this.attribute("width").value),this.attribute("height").hasValue()&&(t.attribute("height",!0).value=this.attribute("height").value),t},this.path=function(t){var e=this.getDefinition();null!=e&&e.path(t)},this.getBoundingBox=function(){var t=this.getDefinition();if(null!=t)return t.getBoundingBox()},this.renderChildren=function(t){var e=this.getDefinition();if(null!=e){var i=e.parent;e.parent=null,e.render(t),e.parent=i}}},t.Element.use.prototype=new t.Element.RenderedElementBase,t.Element.mask=function(e){this.base=t.Element.ElementBase,this.base(e),this.apply=function(e,i){var n=this.attribute("x").toPixels("x"),a=this.attribute("y").toPixels("y"),s=this.attribute("width").toPixels("x"),r=this.attribute("height").toPixels("y");if(0==s&&0==r){for(var o=new t.BoundingBox,l=0;l<this.children.length;l++)o.addBoundingBox(this.children[l].getBoundingBox());var n=Math.floor(o.x1),a=Math.floor(o.y1),s=Math.floor(o.width()),r=Math.floor(o.height())}var h=i.attribute("mask").value;i.attribute("mask").value="";var u=document.createElement("canvas");u.width=n+s,u.height=a+r;var f=u.getContext("2d");this.renderChildren(f);var c=document.createElement("canvas");c.width=n+s,c.height=a+r;var d=c.getContext("2d");i.render(d),d.globalCompositeOperation="destination-in",d.fillStyle=f.createPattern(u,"no-repeat"),d.fillRect(0,0,n+s,a+r),e.fillStyle=d.createPattern(c,"no-repeat"),e.fillRect(0,0,n+s,a+r),i.attribute("mask").value=h},this.render=function(t){}},t.Element.mask.prototype=new t.Element.ElementBase,t.Element.clipPath=function(e){this.base=t.Element.ElementBase,this.base(e),this.apply=function(e){for(var i=0;i<this.children.length;i++){var n=this.children[i];if(void 0!==n.path){var a=null;n.attribute("transform").hasValue()&&(a=new t.Transform(n.attribute("transform").value),a.apply(e)),n.path(e),e.clip(),a&&a.unapply(e)}}},this.render=function(t){}},t.Element.clipPath.prototype=new t.Element.ElementBase,t.Element.filter=function(e){this.base=t.Element.ElementBase,this.base(e),this.apply=function(t,e){var i=e.getBoundingBox(),n=Math.floor(i.x1),a=Math.floor(i.y1),s=Math.floor(i.width()),r=Math.floor(i.height()),o=e.style("filter").value;e.style("filter").value="";for(var l=0,h=0,u=0;u<this.children.length;u++){var f=this.children[u].extraFilterDistance||0;l=Math.max(l,f),h=Math.max(h,f)}var c=document.createElement("canvas");c.width=s+2*l,c.height=r+2*h;var d=c.getContext("2d");d.translate(-n+l,-a+h),e.render(d);for(var u=0;u<this.children.length;u++)this.children[u].apply(d,0,0,s+2*l,r+2*h);t.drawImage(c,0,0,s+2*l,r+2*h,n-l,a-h,s+2*l,r+2*h),e.style("filter",!0).value=o},this.render=function(t){}},t.Element.filter.prototype=new t.Element.ElementBase,t.Element.feMorphology=function(e){this.base=t.Element.ElementBase,this.base(e),this.apply=function(t,e,i,n,a){}},t.Element.feMorphology.prototype=new t.Element.ElementBase,t.Element.feColorMatrix=function(e){function i(t,e,i,n,a,s){return t[i*n*4+4*e+s]}function n(t,e,i,n,a,s,r){t[i*n*4+4*e+s]=r}this.base=t.Element.ElementBase,this.base(e),this.apply=function(t,e,a,s,r){for(var o=t.getImageData(0,0,s,r),a=0;a<r;a++)for(var e=0;e<s;e++){var l=i(o.data,e,a,s,r,0),h=i(o.data,e,a,s,r,1),u=i(o.data,e,a,s,r,2),f=(l+h+u)/3;n(o.data,e,a,s,r,0,f),n(o.data,e,a,s,r,1,f),n(o.data,e,a,s,r,2,f)}t.clearRect(0,0,s,r),t.putImageData(o,0,0)}},t.Element.feColorMatrix.prototype=new t.Element.ElementBase,t.Element.feGaussianBlur=function(e){this.base=t.Element.ElementBase,this.base(e),this.blurRadius=Math.floor(this.attribute("stdDeviation").numValue()),this.extraFilterDistance=this.blurRadius,this.apply=function(e,i,n,a,s){if(void 0===stackBlurCanvasRGBA)return void("undefined"!=typeof console&&console.log("ERROR: StackBlur.js must be included for blur to work"));e.canvas.id=t.UniqueId(),e.canvas.style.display="none",document.body.appendChild(e.canvas),stackBlurCanvasRGBA(e.canvas.id,i,n,a,s,this.blurRadius),document.body.removeChild(e.canvas)}},t.Element.feGaussianBlur.prototype=new t.Element.ElementBase,t.Element.title=function(t){},t.Element.title.prototype=new t.Element.ElementBase,t.Element.desc=function(t){},t.Element.desc.prototype=new t.Element.ElementBase,t.Element.MISSING=function(t){"undefined"!=typeof console&&console.log("ERROR: Element '"+t.nodeName+"' not yet implemented.")},t.Element.MISSING.prototype=new t.Element.ElementBase,t.CreateElement=function(e){var i=e.nodeName.replace(/^[^:]+:/,"");i=i.replace(/\-/g,"");var n=null;return n=void 0!==t.Element[i]?new t.Element[i](e):new t.Element.MISSING(e),n.type=e.nodeName,n},t.load=function(e,i){t.loadXml(e,t.ajax(i))},t.loadXml=function(e,i){t.loadXmlDoc(e,t.parseXml(i))},t.loadXmlDoc=function(e,i){t.init(e);var n=function(t){for(var i=e.canvas;i;)t.x-=i.offsetLeft,t.y-=i.offsetTop,i=i.offsetParent;return window.scrollX&&(t.x+=window.scrollX),window.scrollY&&(t.y+=window.scrollY),t};1!=t.opts.ignoreMouse&&(e.canvas.onclick=function(e){var i=n(new t.Point(null!=e?e.clientX:event.clientX,null!=e?e.clientY:event.clientY));t.Mouse.onclick(i.x,i.y)},e.canvas.onmousemove=function(e){var i=n(new t.Point(null!=e?e.clientX:event.clientX,null!=e?e.clientY:event.clientY));t.Mouse.onmousemove(i.x,i.y)});var a=t.CreateElement(i.documentElement);a.root=!0;var s=!0,r=function(){t.ViewPort.Clear(),
e.canvas.parentNode&&t.ViewPort.SetCurrent(e.canvas.parentNode.clientWidth,e.canvas.parentNode.clientHeight),1!=t.opts.ignoreDimensions&&(a.style("width").hasValue()&&(e.canvas.width=a.style("width").toPixels("x"),e.canvas.style.width=e.canvas.width+"px"),a.style("height").hasValue()&&(e.canvas.height=a.style("height").toPixels("y"),e.canvas.style.height=e.canvas.height+"px"));var n=e.canvas.clientWidth||e.canvas.width,r=e.canvas.clientHeight||e.canvas.height;if(1==t.opts.ignoreDimensions&&a.style("width").hasValue()&&a.style("height").hasValue()&&(n=a.style("width").toPixels("x"),r=a.style("height").toPixels("y")),t.ViewPort.SetCurrent(n,r),null!=t.opts.offsetX&&(a.attribute("x",!0).value=t.opts.offsetX),null!=t.opts.offsetY&&(a.attribute("y",!0).value=t.opts.offsetY),null!=t.opts.scaleWidth&&null!=t.opts.scaleHeight){var o=1,l=1,h=t.ToNumberArray(a.attribute("viewBox").value);a.attribute("width").hasValue()?o=a.attribute("width").toPixels("x")/t.opts.scaleWidth:isNaN(h[2])||(o=h[2]/t.opts.scaleWidth),a.attribute("height").hasValue()?l=a.attribute("height").toPixels("y")/t.opts.scaleHeight:isNaN(h[3])||(l=h[3]/t.opts.scaleHeight),a.attribute("width",!0).value=t.opts.scaleWidth,a.attribute("height",!0).value=t.opts.scaleHeight,a.attribute("viewBox",!0).value="0 0 "+n*o+" "+r*l,a.attribute("preserveAspectRatio",!0).value="none"}1!=t.opts.ignoreClear&&e.clearRect(0,0,n,r),a.render(e),s&&(s=!1,"function"==typeof t.opts.renderCallback&&t.opts.renderCallback(i))},o=!0;t.ImagesLoaded()&&(o=!1,r()),t.intervalID=setInterval(function(){var e=!1;if(o&&t.ImagesLoaded()&&(o=!1,e=!0),1!=t.opts.ignoreMouse&&(e|=t.Mouse.hasEvents()),1!=t.opts.ignoreAnimation)for(var i=0;i<t.Animations.length;i++)e|=t.Animations[i].update(1e3/t.FRAMERATE);"function"==typeof t.opts.forceRedraw&&1==t.opts.forceRedraw()&&(e=!0),e&&(r(),t.Mouse.runEvents())},1e3/t.FRAMERATE)},t.stop=function(){t.intervalID&&clearInterval(t.intervalID)},t.Mouse=new function(){this.events=[],this.hasEvents=function(){return 0!=this.events.length},this.onclick=function(t,e){this.events.push({type:"onclick",x:t,y:e,run:function(t){t.onclick&&t.onclick()}})},this.onmousemove=function(t,e){this.events.push({type:"onmousemove",x:t,y:e,run:function(t){t.onmousemove&&t.onmousemove()}})},this.eventElements=[],this.checkPath=function(t,e){for(var i=0;i<this.events.length;i++){var n=this.events[i];e.isPointInPath&&e.isPointInPath(n.x,n.y)&&(this.eventElements[i]=t)}},this.checkBoundingBox=function(t,e){for(var i=0;i<this.events.length;i++){var n=this.events[i];e.isPointInBox(n.x,n.y)&&(this.eventElements[i]=t)}},this.runEvents=function(){t.ctx.canvas.style.cursor="";for(var e=0;e<this.events.length;e++)for(var i=this.events[e],n=this.eventElements[e];n;)i.run(n),n=n.parent;this.events=[],this.eventElements=[]}},t}this.canvg=function(e,i,n){if(null!=e||null!=i||null!=n){n=n||{},"string"==typeof e&&(e=document.getElementById(e)),null!=e.svg&&e.svg.stop();var a=t();1==e.childNodes.length&&"OBJECT"==e.childNodes[0].nodeName||(e.svg=a),a.opts=n;var s=e.getContext("2d");void 0!==i.documentElement?a.loadXmlDoc(s,i):"<"==i.substr(0,1)?a.loadXml(s,i):a.load(s,i)}else for(var r=document.getElementsByTagName("svg"),o=0;o<r.length;o++){var l=r[o],h=document.createElement("canvas");h.width=l.clientWidth,h.height=l.clientHeight,l.parentNode.insertBefore(h,l),l.parentNode.removeChild(l);var u=document.createElement("div");u.appendChild(l),canvg(h,u.innerHTML)}}}(),"undefined"!=typeof CanvasRenderingContext2D&&(CanvasRenderingContext2D.prototype.drawSvg=function(t,e,i,n,a){canvg(this.canvas,t,{ignoreMouse:!0,ignoreAnimation:!0,ignoreDimensions:!0,ignoreClear:!0,offsetX:e,offsetY:i,scaleWidth:n,scaleHeight:a})}),function(t,e){"use strict";function i(t,e){var i=s(e),n=g.rect({x:-i.left,y:-i.top,width:i.left+i.right,height:i.top+i.bottom});if(e.width&&e.height){var a=t.width+i.left+i.right,r=t.height+i.top+i.bottom;n.scale(a/e.width,r/e.height)}return g.Rect(t).moveAndExpand(n)}function n(t){var i=1;if(!e.isUndefined(t)&&(i=parseFloat(t),!e.isFinite(i)||0===i))throw new Error("dia.Paper: invalid raster size ("+t+")");return i}function a(t,e){return{width:(t.width||1)*e,height:(t.height||1)*e}}function s(e){var i=t.util.normalizeSides(e.padding);return e.width&&e.height&&(i.left+i.right>=e.width&&(i.left=i.right=0),i.top+i.bottom>=e.height&&(i.top=i.bottom=0)),i}function r(t){return t.replace(/\<image[^>]*>/g,function(t){var e=t.match(/href="([^"]*)"/)[1];if("data:image/svg+xml"===e.substr(0,"data:image/svg+xml".length)){var i=atob(e.substr(e.indexOf(",")+1));return i.substr(i.indexOf("<svg"))}return t})}t.dia.Paper.prototype.toDataURL=function(t,s){if("function"!=typeof this.toSVG)throw new Error("The joint.format.svg.js plugin must be loaded.");s=s||{},s.boundBox||(s.boundBox=this.getContentBBox());var o,l=V.transformRect(s.boundBox,this.matrix().inverse()),h=i(l,s),u=s.width&&s.height?s:h,f=a(u,n(s.size)),c=new Image;c.onload=function(){function i(){h=document.createElement("canvas"),h.width=f.width,h.height=f.height,l=h.getContext("2d"),l.fillStyle=s.backgroundColor||"white",l.fillRect(0,0,f.width,f.height)}function n(){a=h.toDataURL(s.type,s.quality),t(a),h.svg&&e.isFunction(h.svg.stop)&&e.defer(h.svg.stop)}var a,l,h;i();try{l.drawImage(c,0,0,f.width,f.height),n()}catch(t){if("undefined"==typeof canvg)return void console.error("Canvas tainted. Canvg library required.");i();var u={ignoreDimensions:!0,ignoreClear:!0,ignoreMouse:!0,ignoreAnimation:!0,offsetX:0,offsetY:0,useCORS:!0};canvg(h,o,e.extend(u,{forceRedraw:e.once(function(){return!0}),renderCallback:function(){try{n()}catch(t){o=r(o),i(),canvg(h,o,e.extend(u,{renderCallback:n}))}}}))}},this.toSVG(function(t){o=t=t.replace('width="100%"','width="'+f.width+'"').replace('height="100%"','height="'+f.height+'"'),c.src="data:image/svg+xml,"+encodeURIComponent(t)},{convertImagesToDataUris:!0,area:h})},t.dia.Paper.prototype.toPNG=function(t,e){e=e||{},e.type="image/png",this.toDataURL(t,e)},t.dia.Paper.prototype.toJPEG=function(t,e){e=e||{},e.type="image/jpeg",this.toDataURL(t,e)},t.dia.Paper.prototype.openAsPNG=function(t){var i=e.uniqueId("png_output");this.toPNG(function(t){window.open("",i,"menubar=yes,location=yes,resizable=yes,scrollbars=yes,status=yes").document.write('<img src="'+t+'"/>')},e.extend({padding:10},t))}}(joint,_);