// FileBufferReader.js is MIT licensed: www.WebRTC-Experiment.com/licence

/*
    Copyright 2013 Eiji Kitamura

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

         http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Author: Eiji Kitamura (agektmr@gmail.com)
    */

!function(){function e(e,n){if(e||(e={}),!n)return e;for(var r in n)e[r]=n[r];return e}window.FileBufferReader=function(){var e=this;e.chunks={},e.readAsArrayBuffer=function(r,t,a){a=a||{},a.chunkSize=a.chunkSize||12e3,n.Read(r,function(n){r.extra=a||{},r.url=URL.createObjectURL(r),n.file=r,e.chunks[n.uuid]=n,t(n.uuid)},a)},e.getNextChunk=function(n,t){var a=e.chunks[n];if(a){var i=a.listOfChunks[a.currentPosition],o=i&&i.end;r.ConvertToArrayBuffer(i,function(r){0==a.currentPosition&&e.onBegin(a.file),o&&e.onEnd(a.file),t(r,o,i.extra),e.onProgress({currentPosition:a.currentPosition,maxChunks:a.maxChunks,uuid:a.uuid,extra:i.extra}),e.chunks[n].currentPosition++})}},e.onBegin=e.onProgress=e.onEnd=function(){};var t=new n.Receiver(e);e.addChunk=function(e,n){t.receive(e,function(e){r.ConvertToArrayBuffer({readyForNextChunk:!0,uuid:e},n)})},e.convertToObject=r.ConvertToObject,e.convertToArrayBuffer=r.ConvertToArrayBuffer},window.FileSelector=function(){function e(e,r){var t=document.createElement("input");t.type="file",r&&(t.multiple=!0),t.onchange=function(){e(r?t.files:t.files[0])},n(t)}function n(e){var n=new window.MouseEvent("click",{view:window,bubbles:!0,cancelable:!0});e.dispatchEvent(n)}var r=this;r.selectSingleFile=e,r.selectMultipleFiles=function(n){e(n,!0)}};var n={Read:function(e,n,r){function t(e,n,t){a=Math.ceil(n.byteLength/c);for(var s=0;s<a;s++){var A=s*c;u[o]={uuid:d,value:n.slice(A,Math.min(A+c,n.byteLength)),currentPosition:o,maxChunks:l,extra:r},o++}o==l&&(i=!0),t()}var a,i,o=1,u={},c=r.chunkSize||6e4,s=0,A=c,R=Math.floor(Math.min(1e8,A)/c),f=R*c,l=Math.ceil(e.size/c),d=e.uuid||(Math.random()*(new Date).getTime()).toString(36).replace(/\./g,"-");u[0]={uuid:d,maxChunks:l,size:e.size,name:e.name,lastModifiedDate:e.lastModifiedDate+"",type:e.type,start:!0,extra:r},e.maxChunks=l,e.uuid=d;var h,v=new FileReader;v.onloadend=function(a){a.target.readyState==FileReader.DONE&&t(e.name,a.target.result,function(){s++,(s+1)*f<e.size?(h=e.slice(s*f,(s+1)*f),v.readAsArrayBuffer(h)):s*f<e.size?(h=e.slice(s*f,e.size),v.readAsArrayBuffer(h)):(u[o]={uuid:d,maxChunks:l,size:e.size,name:e.name,lastModifiedDate:e.lastModifiedDate+"",type:e.type,end:!0,extra:r},n({currentPosition:0,listOfChunks:u,maxChunks:l+1,uuid:d,extra:r}))})},h=e.slice(s*f,(s+1)*f),v.readAsArrayBuffer(h)},Receiver:function(n){function t(i,o){if(!i.uuid)return void r.ConvertToObject(i,function(e){t(e)});if(i.start&&!a[i.uuid]&&(a[i.uuid]=[],n.onBegin&&n.onBegin(i)),!i.end&&i.value&&a[i.uuid].push(i.value),i.end){for(var u=a[i.uuid],c=[],s=u.length,A=0;A<s;A++)u[A]&&c.push(u[A]);var R=new Blob(c,{type:i.type});R=e(R,i),R.url=URL.createObjectURL(R),R.uuid=i.uuid,R.size||console.error("Something went wrong. Blob Size is 0."),n.onEnd&&n.onEnd(R)}i.value&&n.onProgress&&n.onProgress(i),i.end||o(i.uuid)}var a={};return{receive:t}},SaveToDisk:function(e,n){var r=document.createElement("a");r.href=e,r.target="_blank",r.download=n||e;var t=new MouseEvent("click",{view:window,bubbles:!0,cancelable:!0});r.dispatchEvent(t),(window.URL||window.webkitURL).revokeObjectURL(r.href)}},r={ConvertToArrayBuffer:function(e,n){binarize.pack(e,function(e){n(e.buffer)})},ConvertToObject:function(e,n){binarize.unpack(e,n)}};!function(e){var n=Uint8Array.BYTES_PER_ELEMENT,r=Uint16Array.BYTES_PER_ELEMENT,t=Uint32Array.BYTES_PER_ELEMENT,a={NULL:0,UNDEFINED:1,STRING:2,NUMBER:3,BOOLEAN:4,ARRAY:5,OBJECT:6,INT8ARRAY:7,INT16ARRAY:8,INT32ARRAY:9,UINT8ARRAY:10,UINT16ARRAY:11,UINT32ARRAY:12,FLOAT32ARRAY:13,FLOAT64ARRAY:14,ARRAYBUFFER:15,BLOB:16,FILE:16,BUFFER:17},i=[null,null,"Uint16","Float64","Uint8",null,null,"Int8","Int16","Int32","Uint8","Uint16","Uint32","Float32","Float64","Uint8","Uint8","Uint8"],o=function(e){var n=void 0;if(void 0===e)n=a.UNDEFINED;else if(null===e)n=a.NULL;else{var r=e.constructor.name;if(void 0!==r)n=a[r.toUpperCase()];else switch(typeof e){case"string":n=a.STRING;break;case"number":n=a.NUMBER;break;case"boolean":n=a.BOOLEAN;break;case"object":e instanceof Array?n=a.ARRAY:e instanceof Int8Array?n=a.INT8ARRAY:e instanceof Int16Array?n=a.INT16ARRAY:e instanceof Int32Array?n=a.INT32ARRAY:e instanceof Uint8Array?n=a.UINT8ARRAY:e instanceof Uint16Array?n=a.UINT16ARRAY:e instanceof Uint32Array?n=a.UINT32ARRAY:e instanceof Float32Array?n=a.FLOAT32ARRAY:e instanceof Float64Array?n=a.FLOAT64ARRAY:e instanceof ArrayBuffer?n=a.ARRAYBUFFER:e instanceof Blob?n=a.BLOB:e instanceof Buffer?n=a.BUFFER:e instanceof Object&&(n=a.OBJECT)}}return n},u=function(o){var u=0,c=0,s=0,A=new ArrayBuffer(o[0].byte_length+o[0].header_size),R=new DataView(A);for(c=0;c<o.length;c++){var f=(o[c].header_size,o[c].type),l=o[c].length,d=o[c].value,h=o[c].byte_length,v=i[f],E=null===v?0:e[v+"Array"].BYTES_PER_ELEMENT;switch(f===a.BUFFER?R.setUint8(u,a.BLOB,!1):R.setUint8(u,f,!1),u+=n,f!==a.ARRAY&&f!==a.OBJECT||(R.setUint16(u,l,!1),u+=r),R.setUint32(u,h,!1),u+=t,f){case a.NULL:case a.UNDEFINED:break;case a.STRING:for(s=0;s<l;s++,u+=E)R.setUint16(u,d.charCodeAt(s),!1);break;case a.NUMBER:case a.BOOLEAN:R["set"+v](u,d,!1),u+=E;break;case a.INT8ARRAY:case a.INT16ARRAY:case a.INT32ARRAY:case a.UINT8ARRAY:case a.UINT16ARRAY:case a.UINT32ARRAY:case a.FLOAT32ARRAY:case a.FLOAT64ARRAY:var T=new Uint8Array(R.buffer,u,h);T.set(new Uint8Array(d.buffer)),u+=h;break;case a.ARRAYBUFFER:case a.BUFFER:var T=new Uint8Array(R.buffer,u,h);T.set(new Uint8Array(d)),u+=h;break;case a.BLOB:case a.ARRAY:case a.OBJECT:break;default:throw"TypeError: Unexpected type found."}}return R},c=function(o,u){var s,A,R,f,l,d=0;s=o.getUint8(u,!1),u+=n,s!==a.ARRAY&&s!==a.OBJECT||(A=o.getUint16(u,!1),u+=r),R=o.getUint32(u,!1),u+=t;var h=i[s],v=null===h?0:e[h+"Array"].BYTES_PER_ELEMENT;switch(s){case a.NULL:case a.UNDEFINED:f=null;break;case a.STRING:A=R/v;var E=[];for(d=0;d<A;d++){var T=o.getUint16(u,!1);u+=v,E.push(String.fromCharCode(T))}f=E.join("");break;case a.NUMBER:f=o.getFloat64(u,!1),u+=v;break;case a.BOOLEAN:f=1===o.getUint8(u,!1),u+=v;break;case a.INT8ARRAY:case a.INT16ARRAY:case a.INT32ARRAY:case a.UINT8ARRAY:case a.UINT16ARRAY:case a.UINT32ARRAY:case a.FLOAT32ARRAY:case a.FLOAT64ARRAY:case a.ARRAYBUFFER:l=o.buffer.slice(u,u+R),u+=R,f=s===a.ARRAYBUFFER?l:new e[h+"Array"](l);break;case a.BLOB:if(e.Blob){var U=c(o,u),b=c(o,U.cursor);u=b.cursor,f=new Blob([b.value],{type:U.value})}else l=o.buffer.slice(u,u+R),u+=R,f=new Buffer(l);break;case a.ARRAY:for(f=[],d=0;d<A;d++)l=c(o,u),u=l.cursor,f.push(l.value);break;case a.OBJECT:for(f={},d=0;d<A;d++){var y=c(o,u),B=c(o,y.cursor);u=B.cursor,f[y.value]=B.value}break;default:throw"TypeError: Type not supported."}return{value:f,cursor:u}},s=function(e,n){for(var r=e.length,t=[],a=0,i=0,o=0;o<e.length;o++)!function(o){A(e[o],function(e){if(t[o]=e,i+=e[0].header_size+e[0].byte_length,++a===r){for(var u=[],c=0;c<t.length;c++)u=u.concat(t[c]);n(u,i)}})}(o)},A=function(u,c){var A,R=[],f=1,l=n+t,d=0,h=0,v=u;switch(A=o(u),f=void 0===i[A]||null===i[A]?0:e[i[A]+"Array"].BYTES_PER_ELEMENT,A){case a.UNDEFINED:case a.NULL:break;case a.NUMBER:case a.BOOLEAN:d=f;break;case a.STRING:h=u.length,d+=h*f;break;case a.INT8ARRAY:case a.INT16ARRAY:case a.INT32ARRAY:case a.UINT8ARRAY:case a.UINT16ARRAY:case a.UINT32ARRAY:case a.FLOAT32ARRAY:case a.FLOAT64ARRAY:h=u.length,d+=h*f;break;case a.ARRAY:return void s(u,function(e,n){c([{type:A,length:u.length,header_size:l+r,byte_length:n,value:null}].concat(e))});case a.OBJECT:var E=[];for(var T in u)u.hasOwnProperty(T)&&(E.push(T),E.push(u[T]),h++);return void s(E,function(e,n){c([{type:A,length:h,header_size:l+r,byte_length:n,value:null}].concat(e))});case a.ARRAYBUFFER:d+=u.byteLength;break;case a.BLOB:var U=u.type,b=new FileReader;return b.onload=function(e){s([U,e.target.result],function(e,n){c([{type:A,length:h,header_size:l,byte_length:n,value:null}].concat(e))})},b.onerror=function(e){throw"FileReader Error: "+e},void b.readAsArrayBuffer(u);case a.BUFFER:d+=u.length;break;default:throw'TypeError: Type "'+u.constructor.name+'" not supported.'}c([{type:A,length:h,header_size:l,byte_length:d,value:v}].concat(R))},R=function(e,n){var r=e instanceof DataView?e:new DataView(e);return c(r,0).value},f={pack:function(e,n){try{A(e,function(e){n(u(e))})}catch(e){throw e}},unpack:function(e,n){try{var r=R(e);n(r)}catch(e){throw e}}};"undefined"!=typeof module&&module.exports?module.exports=f:e.binarize=f}("undefined"!=typeof global?global:this)}();